var curr;
var defaultMaintenancePkgInfo, defaultCar;
var mBranchList, selectTime;
var mBOOKINGDAYS, mUNITTIME, mBOOKINGTODAY = 0; //mBOOKINGDAYS：未来几天可以选，mBOOKINGTODAY:当前天能预定不，mUNITTIME时间间隔

mui.init()
mui.plusReady(function() {
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	defaultMaintenancePkgInfo = curr.defaultMaintenancePkgInfo;
	defaultCar = curr.defaultCar;
	getBranchList();
	selectTime = new Date().getTime();
	getSystemDic('BOOKINGDAYS');

});

function createDayList() {
	var index = mBOOKINGTODAY==0?1:0;
	var count = index+mBOOKINGDAYS;
	for(var i = index; i < count; i++) {

		var calendarTable = document.getElementById('calendar_table')
		calendarTable.style.width = i * 60 + 'px'
		var week = getWeek(i);
		var day = getWeekDay(i);
		var dtime = getDayTime(i);
		createDayView(i, week, day, dtime);
	}
	//	createCalendar();
}

function createCalendar() {
	var branchList = document.getElementById('selectDayTr');
	var td = document.createElement("td");
	td.setAttribute('class', 'choose-date');
	var contenthtml = '<div onclick="onCalendarClick();">选日历</div>';
	td.innerHTML = contenthtml;
	branchList.appendChild(td);
}

function onCalendarClick() {

}

function createDayView(index, week, day, dtime) {
	var branchList = document.getElementById('selectDayTr');
	var td = document.createElement("td");
	var createindex = (mBOOKINGTODAY==0?1:0);
	if(index == createindex) {
		td.setAttribute('class', 'active');
		selectTime = dtime;
	}
	td.setAttribute('id', 'td' + index);
	td.setAttribute('value', index);
	td.setAttribute('time', dtime);
	var sdate = new Date(dtime);
	td.addEventListener("tap", function() {
		var id = this.getAttribute('id');
		var td = document.getElementById(id);
		var index = td.getAttribute('value');
		var timevalue = td.getAttribute('time');

		var able = td.getAttribute('class');
		if(able == 'disabled')
			return;
		//选择的日期
		var nowdate = new Date(Number(timevalue));

		selectTime = nowdate.getTime();

		var sdate = new Date(selectTime);
		var branchList = document.getElementById('branchList');
		while(branchList.hasChildNodes()) //当div下还存在子节点时 循环继续
		{
			branchList.removeChild(branchList.firstChild);
		}
		getBranchList();
		var index2 = mBOOKINGTODAY==0?1:0;
	var count = index2+mBOOKINGDAYS;
		for(var i = index2; i < count; i++) {
			var sid = 'td' + i;
			var std = document.getElementById(sid);
			var ableAttr = std.getAttribute('class');

			if(i != index) {
				if(ableAttr != 'disabled')
					std.setAttribute('class', '');
			} else {
				std.setAttribute('class', 'active');
			}
		}
	});
	var contenthtml = '<div class="week-text"><div class="yd-date">' + day + '</div> ' +
		'<div class="yd-week">' + week + '</div></div>';
	td.innerHTML = contenthtml;
	branchList.appendChild(td);
}

function getWeek(val) {
	var nowdate = new Date();
	nowdate.setDate(nowdate.getDate() + val);
	var week = "周" + "日一二三四五六".split("")[nowdate.getDay()];
	return week;
}

function getWeekDay(val) {
	var nowdate = new Date();

	nowdate.setDate(nowdate.getDate() + val);
	//	var day = nowdate.getDate();
	var datstr = (nowdate.getMonth() + 1) + '-' + nowdate.getDate()
	return datstr;
}

function getDayTime(val) {
	var nowdate = new Date();

	nowdate.setDate(nowdate.getDate() + val);
	var day = nowdate.getTime();
	return day;
}

function onSelectConsultantClick() {
	var sdate = new Date(selectTime);

	mui.openWindow({
		url: 'serves_consultant.html',
		id: 'page/serves_consultant.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		createNew:true,
		extras: {
			mBranchList: mBranchList,
			selectTime: selectTime,
			mUNITTIME: mUNITTIME,
			mBOOKINGDAYS: mBOOKINGDAYS,
			mBOOKINGTODAY: mBOOKINGTODAY,
			defaultMaintenancePkgInfo: defaultMaintenancePkgInfo,
			defaultCar: defaultCar
		} //自定义扩展参数
	});
}

function getAvatarAddr() {
	var Avatar = mui('#Avatar')[0]
	Avatar.src = ''
	ajaxunit({
		"url": getIpAndPort() + "account/getAvatarAddr.do",
		"method": "post"
	}, function(data) {
		Avatar.src = getIp() + data.result + "?random=" + new Date().getTime()
	})
}

//BR_TWS0105 获取网点列表 获取网点列表；
function getBranchList() {
	var param = {};
	var params = {
		"url": getIpAndPort() + "subscribe/branchList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				mBranchList = response.result;
				createBranchListUI();
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//BR_TWS0110 获取预约时段列表 按网点、日期获取预约时段列表
function getSubscribeTimeList(index, branchId) {
	var param = {
		"branchId": branchId,
		"date": selectTime
	};
	var params = {
		"url": getIpAndPort() + "subscribe/subsribeTimeList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0 && response.result.length > 0) {
				mBranchList[index].SubscribeTime = response.result;
				createSubscribeTimeListUI(index);
			} else {
				//				var tip = response.message;
				//				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点预约时间段数据失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function createBranchListUI() {
	if(mBranchList) {
		mui.each(mBranchList, function(index, item) {
			createBranchUI(item);
			getSubscribeTimeList(index, item.nBID);
		})
	}
}

function createBranchUI(branch) {
	var branchList = document.getElementById('branchList');
	var div = document.createElement("li");
	div.setAttribute('id', branch.nBID);
	var divPriceListID = "div" + branch.nBID;

	var distance = "";

	if(branch.vpos) {

		distance = getDisance(Number(branch.vpos.split(',')[1]), Number(branch.vpos.split(',')[0]));
	}
	var img;
	if(branch.vpicaddr)
		img = getIp() + branch.vpicaddr + "?random=" + new Date().getTime();
	else
		img = "../../img/car_logo.png";
	var contenthtml = '<div class="car-msg mui-clearfix"> ' +
		'<div class="car-logo">' +
		'<img src="' + img + '" />' +
		'</div>' +
		'<div class="car-info">' +
		'<div class="car-name">' +
		'<span id="lbDefaultCarType">' + branch.vBranchName + '</span>' +
		'	<span class="phones">' +
		'		<span></span>' +
		'		<span class="yd-icon-phone" onclick="onPhoneClick(event)" value="' + branch.vPhone + '"></span>' +
		'	</span>' +
		'</div>' +
		'<div class="car-qua">' +
		'	<span class="item">' + branch.vaddr + '</span>' +
		'	<span class="km">' + distance + ' KM</span>' +
		'</div>' +
		'</div>' +
		'</div>' +
		'<div class="price-list" id="' + divPriceListID + '">' +
		'</div>';
	div.innerHTML = contenthtml;

	branchList.appendChild(div);

}
//预约时间段列表SubscribeTime
function createSubscribeTimeListUI(branchIndex) {
	var subscribeTime = mBranchList[branchIndex].SubscribeTime;
	if(subscribeTime) {
		mui.each(subscribeTime, function(index, item) {
			createSubscribeTime(branchIndex, index);
		})
	}
}

function createSubscribeTime(branchIndex, subscribeIndex) {
	var subscribeTime = mBranchList[branchIndex].SubscribeTime[subscribeIndex];
	var divPriceListID = "div" + mBranchList[branchIndex].nBID;
	var subscribeTimeList = document.getElementById(divPriceListID);
	var div = document.createElement("div");
	var nMaterialDisRateStr, nManhDisRateStr;
	if(subscribeTime.nMaterialDisRate == 1) {
		nMaterialDisRateStr = "无折";
	} else if(subscribeTime.nMaterialDisRate == 0) {
		nMaterialDisRateStr = "0折";
	} else {
		nMaterialDisRateStr = subscribeTime.nMaterialDisRate * 10 + "折";
	}
	if(subscribeTime.nManhDisRate == 1) {
		nManhDisRateStr = "1折";
	} else if(subscribeTime.nManhDisRate == 0) {
		nManhDisRateStr = "0折";
	} else {
		nManhDisRateStr = subscribeTime.nManhDisRate * 10 + "折";
	}
	//item mui-clearfix disabled
	var onclickStr;
	if(subscribeTime.nqty < subscribeTime.nTotalQty) {
		div.setAttribute("class", 'item mui-clearfix');
		onclickStr = 'onclick="onOrderClick(event)"';
	} else {
		div.setAttribute("class", 'item mui-clearfix disabled');
	}
	var oldtotalprice = defaultMaintenancePkgInfo.material + defaultMaintenancePkgInfo.workhour;
	var totalprice = defaultMaintenancePkgInfo.material * subscribeTime.nMaterialDisRate +
		defaultMaintenancePkgInfo.workhour * subscribeTime.nManhDisRate;
	var precision = localStorage.getItem(PRECISION);

	if(precision) {
		totalprice = totalprice.toFixed(Number(precision));
		oldtotalprice = oldtotalprice.toFixed(Number(precision));
	} else {
		totalprice = totalprice.toFixed(0);
		oldtotalprice = oldtotalprice.toFixed(0);
	}
	var materId = 'materId' + subscribeIndex;
	var workId = 'workId' + subscribeIndex;
	var contenthtml = '<div class="time">' + subscribeTime.vbegin + '-' + subscribeTime.vEndTime + '</div> ' +
		'<div class="price">' +
		'<span class="price-account">￥' + totalprice + '</span>' +
		'	<div class="benefit">' +
		'	<div id=' + materId + ' class="yellow prefer selecttime">材料' + nMaterialDisRateStr + '</div>' +
		'		<div id=' + workId + '  class="blue prefer selecttime">工时' + nManhDisRateStr + '</div>' +
		'	</div>' +
		'</div>' +
		'	<a href="javascript:void(0)" oldtotalprice="' + oldtotalprice + '" totalprice="' + totalprice + '" branchIndex ="' + branchIndex + '" subscribeIndex ="' + subscribeIndex + '" class="order-btn" ' + onclickStr + '>预约</a>';

	div.innerHTML = contenthtml;
	subscribeTimeList.appendChild(div);
	var materdiv = document.getElementById(materId);
	var workdiv = document.getElementById(workId);
	if(subscribeTime.nMaterialDisRate == 1) {
		materdiv.style.display = 'none';
	}
	if(subscribeTime.nManhDisRate == 1) {
		workdiv.style.display = 'none';
	}
}

function onOrderClick(event) {

	var branchIndex = event.target.getAttribute("branchIndex");
	var subscribeIndex = event.target.getAttribute("subscribeIndex");
	var oldtotalprice = event.target.getAttribute("oldtotalprice");
	var totalprice = event.target.getAttribute("totalprice");

	var subscribeTime = mBranchList[branchIndex].SubscribeTime[subscribeIndex];
	var data = getShowSelectTimeData1(subscribeTime);
	var picker = new mui.PopPicker({
		layer: 1
	});

	picker.setData(data);

	picker.show(function(items) {

		var sdate = new Date(selectTime);
		var pdate = new Date(items[0].value);
		sdate.setHours(pdate.getHours());
		sdate.setMinutes(pdate.getMinutes());
		sdate.setSeconds(0);
		sdate.setMilliseconds(0);
		
		selectTime = sdate.getTime();
		console.log("selectTime::"+selectTime);
		getDefaultConsultant(branchIndex, selectTime, subscribeIndex, totalprice, oldtotalprice);
	})
}

function getShowSelectTimeData1(subscribeTime) {
	var now = new Date();
	var vbeginDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vbegin;
	var vendDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vEndTime;

	var vbeginDate = new Date(vbeginDateStr);
	var vendDate = new Date(vendDateStr);
	var endAllMinutes = vendDate.getHours() * 60 + vendDate.getMinutes();
	var beginAllMinutes = vbeginDate.getHours() * 60 + vbeginDate.getMinutes();

	var num = (endAllMinutes - beginAllMinutes) / mUNITTIME;
	var returnDic = new Array();
	var dic2 = new Object();
	dic2.text = vbeginDate.getHours() + "时" + (vbeginDate.getMinutes() > 0 ? vbeginDate.getMinutes() : "00") + "分";
	dic2.value = vbeginDate.getTime();
	returnDic[0] = dic2;
	for(var i = 0; i < num; i++) {

		var temp = new Date(vbeginDate.getTime() + mUNITTIME * 60 * 1000 * (i + 1));

		var tempdic = new Object();
		tempdic.text = temp.getHours() + "时" + (temp.getMinutes() > 0 ? temp.getMinutes() : "00") + "分";
		tempdic.value = temp.getTime();
		returnDic[i + 1] = tempdic;
	}

	return returnDic;
}
////组装时间段弹出框
//function getShowSelectTimeData(subscribeTime) {
//	var now = new Date();
//	var vbeginDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vbegin;
//	var vendDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vEndTime;
//
//	var vbeginDate = new Date(vbeginDateStr);
//	var vendDate = new Date(vendDateStr);
//
//	var bHour = vbeginDate.getHours();
//	var eHour = vendDate.getHours();
//
//	var returnDic = new Array();
//	var dis = eHour - bHour;
//	var childNum = 60 / mUNITTIME;
//	for(var i = 0; i < dis; i++) {
//		var dic2 = new Object();
//		dic2.value = bHour + i;
//		dic2.text = (bHour + i) + "时";
//		dic2.children = new Array();
//		returnDic[i] = dic2;
//		for(var j = 0; j < childNum; j++) {
//			var dicChild = new Object();
//			if(mUNITTIME * j == 0) {
//				dicChild.text = '00分';
//			} else {
//				dicChild.text = mUNITTIME * j;
//			}
//
//			dicChild.value = mUNITTIME * j;
//
//			dic2.children[j] = dicChild;
//		}
//	}
//
//	return returnDic;
//}

function onPhoneClick(event) {
	var phoneNumber = event.target.getAttribute("value");

	plus.device.dial(phoneNumber, false);
	var btnArray = ['拨打', '取消'];
	mui.confirm('是否拨打 ' + phoneNumber + ' ', '提示', btnArray, function(e) {
		if(e.index == 0) {
			plus.device.dial(phoneNumber, false);
		}
	});

}

function getSystemDic(paramCode) {
	var param = {
		"paramCode": paramCode
	};
	var params = {
		"url": getIp() + "generic/dic/param.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				if(paramCode == "BOOKINGDAYS") {
					mBOOKINGDAYS = Number(response.result);
					getSystemDic('UNITTIME');

				} else if(paramCode == "UNITTIME") {
					mUNITTIME = Number(response.result);
					getSystemDic('BOOKINGTODAY');
				} else {
					mBOOKINGTODAY = Number(response.result);
					createDayList();
				}

			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点预约时间段数据失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//BR_TWS0120 获取默认服务顾问 取出客户默认服务顾问，即上一次为客户服务的服务顾问
function getDefaultConsultant(branchIndex, sdate, subscribeIndex, totalprice, oldtotalprice) {
	var subscribeTime = mBranchList[branchIndex].SubscribeTime[subscribeIndex];
	
	var param = {
		"branchId": mBranchList[branchIndex].nBID,
		"date": sdate,
		"timeId": subscribeTime.nTimeID
	};
	var params = {
		"url": getIpAndPort() + "subscribe/defaultConsultant.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('正获取默认顾问...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				mui.openWindow({
					url: 'appointmentInfo.html',
					id: 'page/appointmentInfo.html',
					styles: {
						top: '0px',
						bottom: '0px'
					}, //窗口参数
					createNew:true,
					extras: {
						mBranch: mBranchList[branchIndex],
						mConsultant: response.result,
						pindex: null,
						selectTime: selectTime,
						subscribeIndex: subscribeIndex,
						defaultMaintenancePkgInfo: defaultMaintenancePkgInfo,
						defaultCar: defaultCar,
						totalprice: totalprice,
						oldtotalprice: oldtotalprice
						
					} //自定义扩展参数
				});

			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取数据失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}