var curr;
var orderID, orderInfo;
mui.init();
mui.plusReady(function() {
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	orderID = curr.orderID;
	getSubScribeInfo();
	ishowBack = curr.isShowBack;
	var orderId = document.getElementById('cmBack');
	var cmfinish = document.getElementById('cmfinish');
	if(ishowBack!=1){
		orderId.style.display = "none";
	}else{
		cmfinish.style.display = "none"; 
	}
});

//获取订单详情
function getSubScribeInfo() {
	var param = {
		"subId": orderID
	};
	var params = {
		"url": getIpAndPort() + "subscribe/subscribeInfo.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting("正在获取订单详情，请稍等");
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				orderInfo = response.result;
				initUIandData();
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
				curr.close();
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
			curr.close();
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		plus.nativeUI.toast("请求失败!");
		curr.close();
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
function onFinishClick(){
	goHome();
	curr.close()
}
function initUIandData() {
	var orderId = document.getElementById('orderId');
	orderId.innerHTML = orderInfo.vBillNo;
	var payStateId = document.getElementById('payStateId');
	var payStatus = JSON.parse(localStorage.getItem(PAYSTATUS));
	
	payStateId.innerHTML = payStatus[orderInfo.vPayStatus];
	
	var canceldiv = document.getElementById('canceldiv');
	var paydiv = document.getElementById('paydiv');
	if(orderInfo.vPayStatus == '0') {//'未付款';
		canceldiv.setAttribute('class','item');
		paydiv.setAttribute('class','item');
		paydiv.style.display = 'block'
	}else{
		canceldiv.setAttribute('class','item only');
		paydiv.setAttribute('class','item');
		paydiv.style.display = 'none'
	}
//	else if(orderInfo.vPayStatus == '1') {//'已付款';
//		
//		canceldiv.setAttribute('class','item only');
//		paydiv.setAttribute('class','item');
//		paydiv.setAttribute('style','display: none;')
//	} else if(orderInfo.vPayStatus == '2') {//'退支付';
//		canceldiv.setAttribute('class','item only');
//		paydiv.setAttribute('class','item');
//		paydiv.setAttribute('style','display: none;')
//	} else if(orderInfo.vPayStatus == '3') {//'已付款';
//		
//		canceldiv.setAttribute('class','item only');
//		paydiv.setAttribute('class','item');
//		paydiv.setAttribute('style','display: none;')
//	}
	var repairId = document.getElementById('repairId');
	
	var repairStatus = JSON.parse(localStorage.getItem(BOOKINGSTATUS));
	
	repairId.innerHTML = repairStatus[orderInfo.vStatus];
	
	if(orderInfo.vStatus == '0') {
//		repairId.innerHTML = '待进厂';
	} else if(orderInfo.vStatus == '1') {
//		repairId.innerHTML = '已进厂';
	} else if(orderInfo.vStatus == '2') {
//		repairId.innerHTML = '取消预约';
		
		canceldiv.style.display = 'none'
		paydiv.style.display = 'none'
	} else if(orderInfo.vStatus == '3') {
//		repairId.innerHTML = '逾期';
		canceldiv.style.display = 'none'
		paydiv.style.display = 'none'
	} else if(orderInfo.vStatus == '5') {
//		repairId.innerHTML = '已完成';
		canceldiv.style.display = 'none'
		
	}
	var sexId = document.getElementById('sexId');
	var customerName = document.getElementById('customerName');
	if(orderInfo.vlinkman)
		customerName.innerHTML = orderInfo.vlinkman;
	else{
		var user = JSON.parse(localStorage.getItem('user'));
		customerName.innerHTML = user.cusName;
	}
	var vLicense = document.getElementById('vLicense');
	vLicense.innerHTML = orderInfo.vLicense;
	var customerPhone = document.getElementById('customerPhone');
	customerPhone.innerHTML = orderInfo.vlinkmanmobile ? orderInfo.vMobile : "";
	var maintenanceName = document.getElementById('maintenanceName');
	var materialIOriginalDic = document.getElementById('materialIOriginalDic');
	var workDic = document.getElementById('workDic');
	var totalPriceDic = document.getElementById('totalPriceDic');
	var totalPrice = document.getElementById('totalPrice');
	var tprice = orderInfo.nManhamt+orderInfo.nMaterialAmt;
	var tpricedic = orderInfo.nManhamtDis+orderInfo.nMaterialAmtDis;
	totalPriceDic.innerHTML = '¥' + tpricedic;
	totalPrice.innerHTML = '¥' + tprice;
	maintenanceName.innerHTML = orderInfo.vpkgname.substring(0,15)+"...";
	if(orderInfo.nMaterialDisRate == 0) {
		materialIOriginalDic.innerHTML = "材料免费"
	} else if(orderInfo.nMaterialDisRate == 1) {
		materialIOriginalDic.innerHTML = "材料无优惠"
	} else {
		materialIOriginalDic.innerHTML = "材料" + orderInfo.nMaterialDisRate * 10 + "折";
	}
	if(orderInfo.nManhDisRate == 1) {
		workDic.innerHTML = "工时无优惠";
	} else if(orderInfo.nManhDisRate == 0) {
		workDic.innerHTML = "工时免费";
	} else {
		workDic.innerHTML = "工时" + orderInfo.nManhDisRate * 10 + "折";
	}

	var stime = document.getElementById('stimeDiv');
	var sdate = new Date();
	sdate.setTime(orderInfo.dBookingTime);
	console.log("sdate:"+sdate);
	stime.innerHTML = sdate.Format("yyyy-MM-dd");
	var subsribeTimeDiv = document.getElementById('subsribeTimeDiv');
	
	subsribeTimeDiv.innerHTML = sdate.getHours()+':'+(sdate.getMinutes()>0?sdate.getMinutes():"00");
	var sale = document.getElementById('sale');

		sale.innerHTML = orderInfo.consultantName;
	var branchName = document.getElementById('branchName');
	branchName.innerHTML = orderInfo.vBranchName+"欢迎您";
	var businessTime = document.getElementById('businessTime');
	businessTime.innerHTML = orderInfo.vWorkTime;
	var addressId = document.getElementById('addressId');
	addressId.innerHTML = orderInfo.vaddr;
	var branchPhone = document.getElementById('branchPhone');
	branchPhone.innerHTML = orderInfo.vPhone;
	
	branchPhone.addEventListener('tap',function(){
		var btnArray = ['拨打', '取消'];
		plus.device.dial(orderInfo.vPhone, false);
	});
}
//BR_TWS0160 取消预约 取消客户预约单；
function onCancelOrderClick() {

	var param = {
		"subId": orderID
	};
	var params = {
		"url": getIpAndPort() + "subscribe/cancelSubscribe.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('取消预约中...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				var result = response.result;
				plus.nativeUI.toast("取消预约成功!");
				onFinishClick();
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("取消预约失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function onPayClick() {
	mui.openWindow({
		url: 'pay_info.html',
		id: 'page/pay_info.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		createNew:true,
		extras: {
			OrderInfo:orderInfo
		} //自定义扩展参数
	});
}
// 对Date的扩展，将 Date 转化为指定格式的String
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符， 
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字) 
// 例子： 
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423 
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18 
Date.prototype.Format = function (fmt) { //author: meizz 
    var o = {
        "M+": this.getMonth() + 1, //月份 
        "d+": this.getDate(), //日 
        "h+": this.getHours(), //小时 
        "m+": this.getMinutes(), //分 
        "s+": this.getSeconds(), //秒 
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度 
        "S": this.getMilliseconds() //毫秒 
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
    if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

//BR_TWS0145 获取服务顾问列表 预约确认时切换服务顾问，获取网点所有可用服务顾问列表
function getCustomerConsultantList() {
	var param = {
		"branchId": mBranch.nBID,
		"subDate": selectTime
	};
	var params = {
		"url": getIpAndPort() + "subscribe/customerConsultantList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				customerConsultantList = response.result;
				createMaskUI(1);
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}