var curr;
var mCarsList = null;
var defaultCar = null;
var mask, changeMileMask;
var user = null;
mui.init();
mui.plusReady(function() {

	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");

	mui(document).on('tap', '#maintenanceButton', maintenanceButtonClick)
	mui(document).on('tap', '#manualButton', manualButtonClick)

	user = JSON.parse(localStorage.getItem('user'));

	initUI();

	addReloadPageEvent();

	initMask();
	mui(".mui-table-view").on('tap', '.mui-table-view-cell', function() {
		//获取id
		var id = this.getAttribute("value");
		//传值给详情页面，通知加载新数据
		mask.close();
		defaultCar = mCarsList[id];
		updateDefaultCarInfo(defaultCar.nVehicleId);
		initMyDefaultCarInfo();
	});
	mui(document).on('tap', '#editKM', function(e) {
		showChangeMileMask();
	});
	mui(document).on('tap', '#lbchangeMile', function(e) {
		showChangeMileMask();
	});

	mui(document).on('tap', '#mile_sure', closeChangeMileMask)

	mui(document).on('tap', '#mile_cancel', onCancelEditClick)

	document.ontouchmove = function(e) {
		//		e.preventDefault()
	}
});

function showChangeMileMask() {
	changeMileMask.show(); //显示遮罩
	mui('#changeMile_box')[0].style.display = 'block'
	showSoftInput();
}

var showSoftInput = function() {
	var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
	if(mui.os.android) {
		//强制当前webview获得焦点
		plus.android.importClass(nativeWebview);
		nativeWebview.requestFocus();
		var Context = plus.android.importClass("android.content.Context");
		var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
		var main = plus.android.runtimeMainActivity();
		var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
		
	} else {
		nativeWebview.plusCallMethod({
			"setKeyboardDisplayRequiresUserAction": false
		});
	}
	var nowInputMile = document.getElementById('nowInputMile');
	nowInputMile.focus();
};

function onCancelEditClick() {
	changeMileMask.close();
}

function closeChangeMileMask() {
	var nowInputMile = document.getElementById('nowInputMile');
	
		uploadLastChangeMile(nowInputMile.value);
		nowInputMile.value = '';
		changeMileMask.close();
	
}

//BR_TWS0081 获取车辆上次里程修改时间 获取车辆上一次里程的修改时间；
function getLastMileUpdate() {
	var param = {
		"vehicleId": defaultCar.nVehicleId
	};
	var params = {
		"url": getIpAndPort() + "vehicle/lastMileUpdate.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
//		//		curr.show();;
		if(response != null) {
			if(response.code == 0) {
				if(response.result) {
					var datenow = new Date(response.result);
					var lbchangeMileTime = document.getElementById('lbchangeMileTime');

					lbchangeMileTime.innerHTML = datenow.getFullYear() + '/' + (datenow.getMonth() + 1) + '/' + datenow.getDate();
				} else {
					var lbchangeMileTime = document.getElementById('lbchangeMileTime');
					lbchangeMileTime.innerHTML = '暂无';
				}
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//BR_TWS0040 更新行驶里程 更新客户车辆当前行驶里程；
function uploadLastChangeMile(lastMile) {
	var param = {
		"vehicleId": defaultCar.nVehicleId,
		"mile": lastMile
	};
	var params = {
		"url": getIpAndPort() + "vehicle/updateMile.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('更新行驶里程中...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		if(response != null) {
			if(response.code == 0) {
				var lbchangeMile = document.getElementById('lbchangeMile');
				lbchangeMile.innerHTML = lastMile + "km";

				//				var lbchangeMileTime = document.getElementById('lbchangeMileTime');
				//				var datenow = new Date();
				//				lbchangeMileTime.innerHTML = datenow.getFullYear() +'/'+ datenow.getMonth() +'/'+ datenow.getDay();
				findMyDefaultCar();
			} else {
				var tip = response.message;

				plus.nativeUI.toast(tip);

			}
		} else {
			plus.nativeUI.toast("更新数据失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

//修改默认车辆
function updateDefaultCarInfo(vehicleId) {
	if(defaultCar == null || defaultCar == "")
		return;

	var param = {
		"vehicleId": vehicleId
	};
	var params = {
		"url": getIpAndPort() + "vehicle/setDefaultVehicle.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		if(response != null) {
			if(response.code == 0) {
				plus.nativeUI.toast("设置默认车辆成功!");
			} else {
				plus.nativeUI.toast("设置默认车辆失败!");
			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		plus.nativeUI.toast("请求失败!");

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//初始化默认车辆显示信息
function initMyDefaultCarInfo() {
	var lbDefaultCarType = document.getElementById('lbDefaultCarType');
	lbDefaultCarType.innerHTML = defaultCar.vSeriesName + defaultCar.vTypeName;
	var lbLise = document.getElementById('lbLise');
	lbLise.innerHTML = defaultCar.vLicense;
	var lbchangeMile = document.getElementById('lbchangeMile');
	var lastInputMile = document.getElementById('lastInputMile');
	lbchangeMile.innerHTML = defaultCar.nMile + "km";
	lastInputMile.value = defaultCar.nMile;
	getMaintenanceMile(defaultCar.nTypeId);

	var carlog = document.getElementById('carlog');
	carlog.src = getIp() + "asset/" + defaultCar.vbrand + ".png"

	//	getLastMileUpdate();
}
//初始化保养套餐
function initMyDefaultCarMileInfo(myMile, mile1, mile2, mile3, time1, time2, time3) {
	var maintenanceMileBefore = document.getElementById('maintenanceMileBefore');
	var maintenanceMileNow = document.getElementById('maintenanceMileNow');
	var maintenanceMileAfter = document.getElementById('maintenanceMileAfter');
	var maintenanceTimeBefore = document.getElementById('maintenanceTimeBefore');
	var maintenanceTimeNow = document.getElementById('maintenanceTimeNow');
	var maintenanceTimeAfter = document.getElementById('maintenanceTimeAfter');

	maintenanceMileBefore.innerHTML = mile1 + "km";
	maintenanceTimeBefore.innerHTML = time1 + "月";

	maintenanceMileNow.innerHTML = mile2 + "km";
	maintenanceTimeNow.innerHTML = time2 + "月";

	maintenanceMileAfter.innerHTML = mile3 + "km";
	maintenanceTimeAfter.innerHTML = time3 + "月";
}

function onCloseShow() {
	mask.close();
}
//初始化车辆选择弹框
function initMask() {
	mask = mui.createMask(function() {
		mui('#carlist_box')[0].style.display = 'none'
	}); //callback为用户点击蒙版时自动执行的回调；

	changeMileMask = mui.createMask(function() {
		mui('#changeMile_box')[0].style.display = 'none'
		var nowInputMile = document.getElementById('nowInputMile');
		nowInputMile.blur()
	}); //callback为用户点击蒙版时自动执行的回调；
}
//初始化界面
function initUI() {

	if(!user) {
		myCarShow(0);
	} else {
		findMyDefaultCar();
		myCarShow(1);
	}
}

//保养预约
function maintenanceButtonClick() {
	user = JSON.parse(localStorage.getItem('user'));
	if(!user) {
		plus.nativeUI.toast("请先登录!");
		return;
	}

	if(defaultCar == null) {
		mui.openWindow({
			url: 'page/msg_in.html',
			id: 'page/msg_in.html',
			styles: {
				top: '0px',
				bottom: '0px'
			}, //窗口参数
			createNew:true,
			extras: {} //自定义扩展参数
		});
	} else {
		mui.openWindow({
			url: 'page/maintenance_info.html',
			id: 'page/maintenance_info.html',
			styles: {
				top: '0px',
				bottom: '0px'
			}, //窗口参数
			createNew:true,
			extras: {
				defaultCar: defaultCar,
				CarsList: mCarsList
			} //自定义扩展参数
		});
	}

}

// 保养手册点击事件
function manualButtonClick() {
	console.log('defaultCar:', JSON.stringify(defaultCar))

	if(defaultCar == null) {
		mui.openWindow({
			url: 'page/msg_in.html',
			id: 'page/msg_in.html',
			styles: {
				top: '0px',
				bottom: '0px'
			}, //窗口参数
			createNew:true,
			extras: {} //自定义扩展参数
		});
	} else {
		mui.openWindow({
			url: 'page/manual.html',
			id: 'page/manual.html',
			styles: {
				top: '0px',
				bottom: '0px'
			}, //窗口参数
			createNew:true,
			extras: {
				defaultCar: defaultCar
			}
		});
	}

}

function myCarShow(isShow) {
	if(isShow == 1) {
		document.getElementById("div_mycar").style.display = "flex";
		document.getElementById("div_regis").style.display = "none";
	} else {
		document.getElementById("div_mycar").style.display = "none";
		document.getElementById("div_regis").style.display = "block";
	}
}

function onRegisterClick() {
	mui.openWindow({
		url: 'page/register.html',
		id: 'register.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
//		createNew:true,
		extras: {
			defaultCar: defaultCar
		}
	});
}

function onSelectCarClick() {
	mask.show();
	mui('#carlist_box')[0].style.display = 'block'
}
//刷新主界面
function addReloadPageEvent() {
	window.addEventListener('reloadpage', function(event) {
		console.log("home reloadpage");
		user = JSON.parse(localStorage.getItem('user'));
		initUI();
		//		getMaintenanceMile();
	});
}
//获取保养手册里程 按车型获取保养手册的里程段数据
//vehicleTypeId:车型Id
function getMaintenanceMile(vehicleTypeId) {
	var param = {
		"vehicleTypeId": vehicleTypeId
	};
	var params = {
		"url": getIpAndPort() + "vehicle/maintenanceMile.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		//		//		curr.show();;
		try {
			if(response) {
				if(response.code == 0) {
					if(response.result && response.result.length > 0) {

						var mymile = defaultCar.nMile;
						var mile1, mile2, mile3, time1, time2, time3, i = 0;

						var newResultObj = {}
						var newResultAry = []

						response.result.forEach(function(item) {
							if(!newResultObj[item.nMile]) {
								newResultObj[item.nMile] = true
								newResultAry.push(item)
							}
						})

						mui.each(newResultAry, function(index, item) {
							if(mymile < item.nMile || mymile == item.nMile) {
								i = index;
								return false;
							}
						});
						if(newResultAry.length == 1) {
							mile1 = newResultAry[0].nMile;
							time1 = newResultAry[0].vMonth;

							mile2 = newResultAry[0].nMile;
							time2 = newResultAry[0].vMonth;

							mile3 = newResultAry[0].nMile;
							time3 = newResultAry[0].vMonth;
						} else if(newResultAry.length == 2) {
							mile1 = newResultAry[0].nMile;
							time1 = newResultAry[0].vMonth;

							mile2 = newResultAry[1].nMile;
							time2 = newResultAry[1].vMonth;

							mile3 = newResultAry[1].nMile;
							time3 = newResultAry[1].vMonth;
						} else {
							if(i < 3) {
								mile1 = newResultAry[0].nMile;
								time1 = newResultAry[0].vMonth;

								mile2 = newResultAry[1].nMile;
								time2 = newResultAry[1].vMonth;

								mile3 = newResultAry[2].nMile;
								time3 = newResultAry[2].vMonth;
							} else {

								mile1 = newResultAry[i - 1].nMile;
								time1 = newResultAry[i - 1].vMonth;

								mile2 = newResultAry[i].nMile;
								time2 = newResultAry[i].vMonth;
								if(i < (newResultAry.length - 1)) {
									mile3 = newResultAry[i + 1].nMile;
									time3 = newResultAry[i + 1].vMonth;
								} else {
									mile3 = newResultAry[i].nMile;
									time3 = newResultAry[i].vMonth;
								}
							}
						}

						initMyDefaultCarMileInfo(mymile, mile1, mile2, mile3, time1, time2, time3);
					} else {
						initMyDefaultCarMileInfo(mymile, 0, 0, 0, 0, 0, 0);
					}
				} else {
					var tip = response.message;
					if(response.code == 1001) {
						myCarShow(0);
					}
					plus.nativeUI.toast(tip);

				}
			} else {
				plus.nativeUI.toast("请求失败!");
			}
		} catch(e) {
			console.log(e)
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		//		curr.show();;
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

//获取车辆列表 获取客户车辆档案列表(包括联系人的车辆)
function getCarslist() {
	var param = {};
	var params = {
		"url": getIpAndPort() + "vehicle/customerAndLinkManVehicleList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		if(response != null) {
			if(response.code == 0) {
				if(response.result != null && response.result != "") {

					mCarsList = response.result;

					createShowCarListView();
					if(defaultCar == null || defaultCar == "") {
						defaultCar = mCarsList[0];
						myCarShow(1);
						initMyDefaultCarInfo();
					}
				}
			} else {
				var tip = response.message;
				if(response.code == 1001) {
					myCarShow(0);
				}
				plus.nativeUI.toast(tip);

			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		plus.nativeUI.toast("请求失败!");

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//获取默认车辆
function findMyDefaultCar() {
	var param = {};
	var params = {
		"url": getIpAndPort() + "vehicle/defaultInfo.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		if(response != null) {
			if(response.code == 0) {
				getCarslist();
				defaultCar = response.result;
				if(response.result != null && response.result != "") {
					initMyDefaultCarInfo();
					myCarShow(1);
				} else {
					myCarShow(0);
				}
			} else {
				var tip = response.message;
				if(response.code == 1001) {
					myCarShow(0);
				}
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		curr.show();;
		plus.nativeUI.toast("请求失败!");

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

//创建弹出框中的列表
function createShowCarListView() {
	console.log("createShowCarListView mCarsList:" + mCarsList.length);
	if(mCarsList != null && mCarsList.length > 0) {
		var tableviewCarlist = document.getElementById('tableviewCarlist');
		while(tableviewCarlist.hasChildNodes()) //当div下还存在子节点时 循环继续
		{
			tableviewCarlist.removeChild(tableviewCarlist.firstChild);
		}
		mui.each(mCarsList, function(index, item) {
			createTablieli(index, item.vLicense, item.vCusName,
				item.vMobile, item.vSeriesName, item.vLinkMan, item.vPhone);
		})
	}
}
//创建弹出框中单项
function createTablieli(index, vLicense, customName, customPhone, carType, contactName, contactPhone) {
	var tableviewCarlist = document.getElementById('tableviewCarlist');
	var div = document.createElement("li");
	div.className = "mui-table-view-cell mui-media";
	div.value = index;

	var str = '<div class="mui-media-body">  ' +
		'<table class="cartable">' +
		'<tr >' +
		'<td width="25%">' +
		'<span class="sale-avt women"></span>' +
		'<span>' + vLicense + '</span>' +
		'</td>' +
		'<td width="30%">' +
		'<span class="hot-1 hot">客户：</span>' +
		'<span class="hot-1 hot">' + (customName || '') + '</span>' +
		'</td>' +
		'<td width="45%">' +
		'	<span class="can-order">' + (customPhone || '') + '</span>' +
		'</td>' +
		'</tr>' +
		'<tr>' +
		'<td >' +
		'<span class="sale-avt women"></span>' +
		'<span>' + carType + '</span>' +
		'</td>' +
		'<td >' +
		'	<span class="hot-1 hot">联系人：</span>' +
		'	<span class="hot-1 hot">' + (contactName || '') + '</span>' +
		'</td>' +
		'<td >' +
		'<span class="can-order">' + (contactPhone || '') + '</span>' +
		'</td>' +
		'</tr>' +
		'</table>' +
		'</div>';

	div.innerHTML = str;

	tableviewCarlist.appendChild(div);
}