var curr, mBranchList, selectTime, mBOOKINGDAYS, mUNITTIME, mBOOKINGTODAY = 0;
var personMask, defaultMaintenancePkgInfo,defaultCar;
var changeDayTime;
mui.init();
mui.plusReady(function(){
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	defaultCar = curr.defaultCar;
	mBranchList = curr.mBranchList;
	selectTime = curr.selectTime;

	mUNITTIME = curr.mUNITTIME;
	mBOOKINGDAYS = curr.mBOOKINGDAYS;
	mBOOKINGTODAY = curr.mBOOKINGTODAY;
	defaultMaintenancePkgInfo = curr.defaultMaintenancePkgInfo;
	
	if(mBranchList) {
		mui.each(mBranchList, function(index, item) {
			createBranchUI(item);
			getConsultantList(index, item);
		})
	}
	initPersonMask();
})

function onCloseShow() {
	changeDayTime=null;
	personMask.close();
}

function showPersonMask() {
	personMask.show();
	mui('#personTime_box')[0].style.display = 'block';
}
//初始化车辆选择弹框
function initPersonMask() {
	personMask = mui.createMask(function() {
		mui('#personTime_box')[0].style.display = 'none'
	}); //callback为用户点击蒙版时自动执行的回调；

}

function createBranchPersonUI(bindex) {
	var branch = mBranchList[bindex];
	var divPreListID = "preList" + branch.nBID;
	var divDivPreList = document.getElementById(divPreListID);

	var row = parseInt(branch.ConsultantList.length / 4);
	
	var cell = branch.ConsultantList.length % 4;

	if(cell > 0) {
		row = row + 1;
	}

	for(var i = 0; i < row; i++) {
		var rowdiv = document.createElement("div");
		rowdiv.setAttribute('class', "sale-list mui-clearfix");

		var lastrow = row - 1;
		var cellnum = 4;
		if(i == lastrow && cell > 0) {
			cellnum = cell;
		}

		for(var j = 0; j < cellnum; j++) {
			var index = i * 4 + j;
			var pdiv = document.createElement("div");
			pdiv.setAttribute('class', "item");
			pdiv.setAttribute('index', index);
			pdiv.setAttribute('id', branch.ConsultantList[index].npsnid);

			pdiv.addEventListener("tap", function() {
				getConsultantHolidayInfo(bindex, this.getAttribute('index'), this.getAttribute('id'));
			});

			var imgDiv = document.createElement("div");
			if(Number(branch.ConsultantList[index].vSex) == 1) {
				imgDiv.setAttribute('class', "avt man"); //avt man
			} else {
				imgDiv.setAttribute('class', "avt women"); //avt man
			}
			pdiv.appendChild(imgDiv);
			
			var nameDiv = document.createElement("div");
			nameDiv.setAttribute('class', "name");
			nameDiv.innerHTML = branch.ConsultantList[index].vpsnname;
			pdiv.appendChild(nameDiv);

			rowdiv.appendChild(pdiv);
			
			var hotTopDiv = document.createElement("div");
			
			if(branch.ConsultantList[index].nrank){
				var rank = Number(branch.ConsultantList[index].nrank);
				switch(rank){
					case 1:
						hotTopDiv.setAttribute('class', "top hot-1");
						hotTopDiv.innerHTML = 'HOT 1';
						break;
					case 2:
						hotTopDiv.setAttribute('class', "top hot-2");
						hotTopDiv.innerHTML = 'HOT 2';
						break;
					case 3:
						hotTopDiv.setAttribute('class', "top hot-3");
						hotTopDiv.innerHTML = 'HOT 3';
						break;
				}
			}

			if(branch.ConsultantList[index].last){
				if(Number(branch.ConsultantList[index].last)==1){
					hotTopDiv.setAttribute('class', "top pre");
					hotTopDiv.innerHTML = '上次咨询';
				}
			}
			
			
			pdiv.appendChild(hotTopDiv);
			
		}

		divDivPreList.appendChild(rowdiv);

	}
}

function createBranchUI(branch) {
	var branchList = document.getElementById('branchList');
	var div = document.createElement("li");
	div.setAttribute('id', branch.nBID);
	var divPreListID = "preList" + branch.nBID;
	var distance = "";
	if(branch.vpos) {
		distance = getDisance(Number(branch.vpos.split(',')[1]), Number(branch.vpos.split(',')[0]));
	}
	if(branch.vpicaddr)
		img = getIp() + branch.vpicaddr + "?random=" + new Date().getTime();
	else
		img = "../../img/car_logo.png";
	var contenthtml = '<div class="title-cotent mui-clearfix">' +
		'<div class="address-icon">' +
		'	<img src="'+img+'"/>' +
		'</div> ' +
		'<div class="titles">' +
		'	<div class="main-title">' + branch.vBranchName + '</div>' +
		'	<div class="sub-title">' + branch.vaddr + '</div> ' +
		'</div> ' +
		'	<div class="phone">' +
		'	<div class="iphone-icon" value="' + branch.vPhone + '" onclick="onPhoneClick(event)"></div> ' +
		'	<div class="how-far">'+distance+' km</div> ' +
		'</div>' +
		'	</div> ' +
		'<div  id="' + divPreListID + '"></div>';

	div.innerHTML = contenthtml;

	branchList.appendChild(div);

}

//BR_TWS0130 获取网点服务顾问列表 获取网点所有可用服务顾问列表
function getConsultantList(index, item) {

	var param = {
		"branchId": item.nBID,
		"subDate": Number(selectTime)
	};
	var params = {
		"url": getIpAndPort() + "subscribe/customerConsultantList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				//
				mBranchList[index].ConsultantList = response.result;
				createBranchPersonUI(index);
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function onPhoneClick(event) {
	var phoneNumber = event.target.getAttribute("value");

	var btnArray = ['拨打', '取消'];
	plus.device.dial(phoneNumber, false);
	//	mui.confirm('是否拨打 ' + phoneNumber + ' ', '提示', btnArray, function(e) {
	//		if(e.index == 0) {
	//			plus.device.dial(phoneNumber, false);
	//		}
	//	});
}
//BR_TWS0135 获取服务顾问预约日期范围 获取服务顾问在可预约日期范围内休假情况
function getConsultantHolidayInfo(bindex, pindex, consultantId) {
	
	var param = {
		"consultantId": consultantId,
		"subDate": Number(selectTime)
	};
	var params = {
		"url": getIpAndPort() + "subscribe/consultantHolidayInfo.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
			
				mBranchList[bindex].ConsultantList[pindex].TimeList = response.result.week;
				createDayList(bindex, pindex);
				createSubscribeTimeListUI(pindex, bindex);

				showPersonMask();
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//创建顾问服务时间段
function createSubscribeTimeListUI(pIndex, bindex) {
	var tableviewCarlist = document.getElementById('tableviewCarlist');
	while(tableviewCarlist.hasChildNodes()) //当div下还存在子节点时 循环继续
	{
		tableviewCarlist.removeChild(tableviewCarlist.firstChild);
	}

	mui.each(mBranchList[bindex].SubscribeTime, function(index, item) {
		createSubscribeTime(pIndex, bindex, index);
	})
}
//创建顾问服务时间段
function createSubscribeTime(pIndex, branchIndex, subscribeIndex) {

	var subscribeTime = mBranchList[branchIndex].SubscribeTime[subscribeIndex];
	
	var li = document.createElement("li");
	li.setAttribute("class", "time-list");
	var onclickStr = 'onclick="onOrderClick(event)"';
	var oldtotalprice = defaultMaintenancePkgInfo.material+defaultMaintenancePkgInfo.workhour;
	var totalprice = defaultMaintenancePkgInfo.material*subscribeTime.nMaterialDisRate+
		defaultMaintenancePkgInfo.workhour*subscribeTime.nManhDisRate;
	var precision= localStorage.getItem(PRECISION);
	
	if(precision){
		totalprice=totalprice.toFixed(Number(precision));
		oldtotalprice = oldtotalprice.toFixed(Number(precision));
	}else{
		totalprice=totalprice.toFixed(0);
		oldtotalprice = oldtotalprice.toFixed(0);
	}
	var contenthtml = '<div class="item mui-clearfix"> ' +
		'<div class="time">' + subscribeTime.vbegin + '-' + subscribeTime.vEndTime + '</div>' +
		'<div class="price">￥' + totalprice + '</div>' +
		'<a href="javascript:void(0)" totalprice='+totalprice+' oldtotalprice='+oldtotalprice+' pIndex ="' + pIndex + '"  branchIndex ="' + branchIndex + '" subscribeIndex ="' + subscribeIndex + '" class="order-btn" ' + onclickStr + '>预约</a>' +
		'</div>';
	li.innerHTML = contenthtml;
	tableviewCarlist.appendChild(li);
}

function createDayList(bindex, pindex) {
	var selectDayTr = document.getElementById('selectDayTr');
	while(selectDayTr.hasChildNodes()) //当div下还存在子节点时 循环继续
	{
		selectDayTr.removeChild(selectDayTr.firstChild);
	}
	var dayList = mBranchList[bindex].ConsultantList[pindex].TimeList;
	console.log("dayList:"+dayList.length);
	for(var i = 0; i < dayList.length; i++) {
		var calendarTable = document.getElementById('calendar_table')
		calendarTable.style.width = i * 60 + 'px'
		for(var key in dayList[i]) {
			var week = getWeek(key);
			var day = getWeekDay(key);
			var dtime = getDayTime(key);
			createDayView(bindex, pindex, i, week, day, dtime, dayList[i][key]);
			if(i==0){
				changeDayTime = dtime;
			}
		}

	}
}

function createDayView(bindex, pindex, index, week, day, dtime, state) {
	var branchList = document.getElementById('selectDayTr');
	var td = document.createElement("td");
	if(index == 0) {
		td.setAttribute('class', 'active');
	}
	if(Number(state) == 1) {
		td.setAttribute('class', 'disabled');
	}
	td.setAttribute('id', 'td' + index);
	td.setAttribute('value', index);
	td.addEventListener("tap", function() {
		var id = this.getAttribute('id');
		var td = document.getElementById(id);
		var index = td.getAttribute('value');
		var able = td.getAttribute('class');
		if(able == 'disabled')
			return;
		//选择的日期
		changeDayTime = dtime;
		var dayList = mBranchList[bindex].ConsultantList[pindex].TimeList;
		
		for(var i = 0; i < dayList.length; i++) {
			
			var sid = 'td' + i;
			var std = document.getElementById(sid);
			var ableAttr = std.getAttribute('class');

			if(i != index) {
				if(ableAttr != 'disabled')
					std.setAttribute('class', '');
			} else {
				std.setAttribute('class', 'active');
			}
		}
	});
	var contenthtml = '<div class="week-text"><div class="yd-date">' + day + '</div> ' +
		'<div class="yd-week">' + week + '</div></div>';
	td.innerHTML = contenthtml;
	branchList.appendChild(td);
}

function getWeek(val) {
	var nowdate = new Date(Number(val));
	var week = "周" + "日一二三四五六".split("")[nowdate.getDay()];

	return week;
}

function getWeekDay(val) {
	var nowdate = new Date(Number(val));
//	var day = nowdate.getDate();
	
	var datstr = (nowdate.getMonth()+1)+'-'+nowdate.getDate()
	return datstr;
}

function getDayTime(val) {
	var nowdate = new Date(Number(val));

	var day = nowdate.getTime();
	return day;
}
//时间段选择
function onOrderClick(event) {

var totalprice = event.target.getAttribute("totalprice");
var oldtotalprice = event.target.getAttribute("oldtotalprice");
	var branchIndex = event.target.getAttribute("branchIndex");
	var subscribeIndex = event.target.getAttribute("subscribeIndex");
	var pindex = event.target.getAttribute("pIndex");
	var subscribeTime = mBranchList[branchIndex].SubscribeTime[subscribeIndex];

	var data = getShowSelectTimeData1(subscribeTime);
	var picker = new mui.PopPicker({
		layer: 1
	});

	picker.setData(data);

	picker.show(function(items) {

		if(changeDayTime)
			selectTime= changeDayTime;
		var sdate=new Date(selectTime);
		var pdate = new Date(items[0].value);
		sdate.setHours(pdate.getHours());
		sdate.setMinutes(pdate.getMinutes());
		sdate.setSeconds(0);
		sdate.setMilliseconds(0);
		selectTime = sdate.getTime();

		checkConsultantCanSubscribe(branchIndex, pindex, subscribeIndex,totalprice,oldtotalprice);

	})
}
//按服务顾问校验时间段 校验服务顾问在此时间段是否可预约
//branchId 网点ID,consultantId 顾问id，date日期，timeId 时间段id
function checkConsultantCanSubscribe(branchIndex, pindex, subscribeIndex,totalprice,oldtotalprice) {

	var branchId, consultantId, sdate, timeId;
	branchId = mBranchList[branchIndex].nBID;
	
	consultantId = mBranchList[branchIndex].ConsultantList[pindex].npsnid;
	timeId = mBranchList[branchIndex].SubscribeTime[subscribeIndex].nTimeID;
	var time = new  Date(selectTime);

	var sdate = new Date(selectTime);

	var param = {
		"branchId": branchId,
		"consultantId": consultantId,
		"date": selectTime,
		"timeId": timeId
	};
	var params = {
		"url": getIpAndPort() + "subscribe/checkConsultantCanSubscribe.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				var result = response.result;
				if(result == "0") {
					mui.openWindow({
						url: 'appointmentInfo.html',
						id: 'page/appointmentInfo.html',
						styles: {
							top: '0px',
							bottom: '0px'
						}, //窗口参数
						createNew:true,
						extras: {
							mBranch: mBranchList[branchIndex],
							pindex:pindex,
							selectTime:selectTime,
							subscribeIndex:subscribeIndex,
							defaultMaintenancePkgInfo:defaultMaintenancePkgInfo,
							defaultCar:defaultCar,
							totalprice:totalprice,
							oldtotalprice:oldtotalprice
						} //自定义扩展参数
					});
				} else if(result == "1"){
					plus.nativeUI.toast("当前顾问休假中，请选择其他顾问!");
				}else{
					plus.nativeUI.toast("当前顾问休假中，请选择其他顾问!");
				}

			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getShowSelectTimeData1(subscribeTime){
	var now = new Date();
	var vbeginDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vbegin;
	var vendDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vEndTime;

	var vbeginDate = new Date(vbeginDateStr);
	var vendDate = new Date(vendDateStr);
	var endAllMinutes = vendDate.getHours()*60+vendDate.getMinutes();
	var beginAllMinutes = vbeginDate.getHours()*60+vbeginDate.getMinutes();
	
	var num= (endAllMinutes - beginAllMinutes)/mUNITTIME;
	var returnDic = new Array();
	var dic2 = new Object();
	dic2.text = vbeginDate.getHours() + "时" +(vbeginDate.getMinutes()>0?vbeginDate.getMinutes():"00")+"分";
	dic2.value = vbeginDate.getTime();
	returnDic[0] = dic2;
	for(var i=0;i<num;i++){
		
		var temp = new Date(vbeginDate.getTime()+mUNITTIME*60*1000*(i+1));
		
		var tempdic = new Object();

		tempdic.text = temp.getHours()+"时"+(temp.getMinutes()>0?temp.getMinutes():"00")+"分";
		tempdic.value = temp.getTime();
		returnDic[i+1] = tempdic;
	}
	
	return returnDic;
}
//组装时间段弹出框
//function getShowSelectTimeData(subscribeTime) {
//	var now = new Date();
//	var vbeginDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vbegin;
//	var vendDateStr = now.getFullYear() + "/" + now.getMonth() + "/" + now.getDay() + " " + subscribeTime.vEndTime;
//
//	var vbeginDate = new Date(vbeginDateStr);
//	var vendDate = new Date(vendDateStr);
//
//	var bHour = vbeginDate.getHours();
//	var eHour = vendDate.getHours();
//
//	var returnDic = new Array();
//	var dis = eHour - bHour+1;
//	var childNum = 60 / mUNITTIME;
//	for(var i = 0; i < dis; i++) {
//		var dic2 = new Object();
//		dic2.value = bHour + i;
//		dic2.text = (bHour + i) + "时";
//		dic2.children = new Array();
//		
//		for(var j = 0; j < childNum; j++) {
//			var dicChild = new Object();
//			if(mUNITTIME * j == 0) {
//				dicChild.text = '00分';
//			} else {
//				dicChild.text = mUNITTIME * j;
//			}
//
//			dicChild.value = mUNITTIME * j;
//
//			dic2.children[j] = dicChild;
//		}
//		returnDic[i] = dic2;
//	}
//
//	return returnDic;
//}