var curr;
var myUseAbleTicketList; //我的可用代金券
var myUnUseAbleTicketList; //我的不可用代金券
mui.init()
mui.plusReady(function() {
	//	initUI();
	curr = plus.webview.currentWebview();

	new Vue({
		el: '#app',
		data: {
			activeIndex: 0,
			ticketList1: [],
			ticketList2: [],
			COUPONCLSS: {}
		},
		mounted: function() {
			plus.nativeUI.showWaiting('正在加载代金券...');
			this.getData(1)
			this.getData(2)
			this.getCOUPONCLSS()
		},
		methods: {
			getData: function(type) {
				var self = this
				ajaxunit({
					"url": getIpAndPort() + "payment/couponList.do",
					"method": "post",
					"pa": {
						type: type
					}
				}, function(data) {
					plus.nativeUI.closeWaiting();
					var result = data.result
					var key = 'ticketList' + type
					self[key] = result
					if (result && result.length) {
						result.forEach(function(ticket) {
							if(ticket.couponList && ticket.couponList.length) {
								ticket.couponList.forEach(function(coupon) {
									coupon.dvalid = timestampformat(coupon.dvalid, 'yyyy.MM.dd')
								})
							}
						})
					}
				});
			},
			getCOUPONCLSS: function() {
				var self = this
				ajaxunit({
					"url": getIp() + "generic/dic/get.do",
					"method": "post",
					"pa": {
						dicId: 'COUPONCLSS'
					}
				}, function(data) {
					var result = data.result
					self.COUPONCLSS = result.items
				});
			}
		}
	})

	//	plus.screen.lockOrientation("portrait-primary");
	//	getTicketInfo(1);
	//	getTicketInfo(2);
});

