var curr;
var defaultMaintenancePkgInfo, mBranch, mConsultant, selectTime, defaultCar, mtotalprice, moldtotalprice;
var pindex; //选的哪个顾问
var subscribeIndex; //选择的时间端
var saleMask;
var customerConsultantList;
var mSelectConsultantId;
mui.init();
mui.plusReady(function() {
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	defaultMaintenancePkgInfo = curr.defaultMaintenancePkgInfo;
	mBranch = curr.mBranch;
	pindex = curr.pindex;
	mConsultant = curr.mConsultant;
	selectTime = curr.selectTime;
	subscribeIndex = curr.subscribeIndex;
	defaultCar = curr.defaultCar;
	mtotalprice = curr.totalprice;
	moldtotalprice = curr.oldtotalprice;
	initUIandData();
	mui(document).on('tap', '#consultantName', function(e) {
		showSaleMask();
	});
	mui(document).on('tap', '#sexSpan', function(e) {
		showSaleMask();
	});
	saleMask = mui.createMask(function() {
		mui('#sale_box')[0].style.display = 'none'
	}); //callback为用户点击蒙版时自动执行的回调；

	getCustomerConsultantList();

	console.log("mBranch.SubscribeTime[subscribeIndex]:" + mBranch.SubscribeTime[subscribeIndex]);
});

function initUIandData() {
	var maintenanceName = document.getElementById('maintenanceName');
	var materialIOriginalDic = document.getElementById('materialIOriginalDic');
	var workDic = document.getElementById('workDic');
	var totalPrice = document.getElementById('totalPrice');
	var oldtotalPrice = document.getElementById('oldtotalPrice');
	if(typeof(mtotalprice) == "undefined") {
		totalPrice.innerHTML = '¥' + defaultMaintenancePkgInfo.totalDis;
	} else {
		totalPrice.innerHTML = '¥' + mtotalprice;
	}
	if(typeof(moldtotalprice) == "undefined") {
		oldtotalPrice.innerHTML = '¥' + defaultMaintenancePkgInfo.total;
	} else {
		oldtotalPrice.innerHTML = '¥' + moldtotalprice;
	}

	maintenanceName.innerHTML = defaultMaintenancePkgInfo.pkgInfo.vpkgname;
	var subscribeTime = mBranch.SubscribeTime[subscribeIndex];
	if(subscribeTime.nMaterialDisRate == 0) {
		materialIOriginalDic.innerHTML = "材料免费"
	} else if(subscribeTime.nMaterialDisRate == 1) {
		materialIOriginalDic.innerHTML = "材料无优惠"
		materialIOriginalDic.style.display = 'none'
	} else {
		materialIOriginalDic.innerHTML = "材料" + subscribeTime.nMaterialDisRate * 10 + "折";
	}
	if(subscribeTime.nManhDisRate == 1) {
		workDic.innerHTML = "工时无优惠";
		workDic.style.display = 'none'
	} else if(subscribeTime.nManhDisRate == 0) {
		workDic.innerHTML = "工时免费";
	} else {
		workDic.innerHTML = "工时" + subscribeTime.nManhDisRate * 10 + "折";
	}

	var stime = document.getElementById('stimeDiv');
	var sdate = new Date(selectTime);

	stime.innerHTML = sdate.toLocaleDateString();
	var subsribeTimeDiv = document.getElementById('subsribeTimeDiv');

	subsribeTimeDiv.innerHTML = sdate.getHours() + ':' + (sdate.getMinutes() > 0 ? sdate.getMinutes() : "00");
	//	subsribeTimeDiv.innerHTML = mBranch.SubscribeTime[subscribeIndex].vbegin + '-' + mBranch.SubscribeTime[subscribeIndex].vEndTime;
	var consultantName = document.getElementById('consultantName');
	var sexSpan = document.getElementById('sexSpan');
	if(pindex) {

		//		sexSpan.style.display = 'block';
		consultantName.innerHTML = mBranch.ConsultantList[pindex].vpsnname;
		if(mBranch.ConsultantList[pindex].vSex == "1") {
			sexSpan.Class = 'avt man';
		} else {
			sexSpan.Class = 'avt woman';
		}
	} else {
		//		sexSpan.style.display = 'none';
		if(mConsultant) {
			consultantName.innerHTML = mConsultant.vpsnname;
			if(mConsultant.vSex == "1") {
				sexSpan.Class = 'avt man';
			} else {
				sexSpan.Class = 'avt woman';
			}
		}
	}

	var customerName = document.getElementById('customerName');
	customerName.innerHTML = defaultCar.vCusName;
	var customerPhone = document.getElementById('customerPhone');
	customerPhone.innerHTML = defaultCar.vMobile ? defaultCar.vMobile : "";
	var linkName = document.getElementById('linkName');
	linkName.innerHTML = defaultCar.vLinkMan ? defaultCar.vLinkMan : defaultCar.vCusName;
	var linkPhone = document.getElementById('linkPhone');
	linkPhone.innerHTML = defaultCar.vMobile ? defaultCar.vMobile : "";
	var vLicense = document.getElementById('vLicense');
	vLicense.innerHTML = defaultCar.vLicense;
}

function showSaleMask() {

	saleMask.show(); //显示遮罩
	mui('#sale_box')[0].style.display = 'block'
}
//limit:1不限制，2:上次 ，3:排除上次
function createMaskUI(limit, name) {
	if(customerConsultantList) {
		var maskbody = document.getElementById('maskbody');
		while(maskbody.hasChildNodes()) //当div下还存在子节点时 循环继续
		{
			maskbody.removeChild(maskbody.firstChild);
		}

		mui.each(customerConsultantList, function(index, item) {

			if(limit == 1) {
				if(name.length > 0) {
					if(item.vpsnname.indexOf(name) >= 0) {
						createMaskChildUI(item, index);
					}
				} else {
					createMaskChildUI(item, index);
				}

			} else if(limit == 2) {
				if(item.last == '1') {
					if(name.length > 0) {
						if(item.vpsnname.indexOf(name) >= 0) {
							createMaskChildUI(item, index);
						}
					} else {
						createMaskChildUI(item, index);
					}
				}
			} else {
				if(item.last == '0') {
					if(name.length > 0) {
						if(item.vpsnname.indexOf(name) >= 0) {
							createMaskChildUI(item, index);
						}
					} else {
						createMaskChildUI(item, index);
					}
				}
			}
		})
	}
}

function createMaskChildUI(Consultant, index) {
	var maskbody = document.getElementById('maskbody');
	var tr = document.createElement("tr");
	tr.setAttribute('value', index);
	var nametd = document.createElement("td");

	nametd.style.textAlign = 'left';
	nametd.style.paddingLeft = '50px'
	var sexSpan = document.createElement("span");
	if(Consultant.vSex == "1") {
		sexSpan.setAttribute('class', 'sale-avt man');
	} else {
		sexSpan.setAttribute('class', 'sale-avt women');
	}
	var nameSpan = document.createElement("span");
	nameSpan.innerHTML = Consultant.vpsnname;
	nametd.appendChild(sexSpan);
	nametd.appendChild(nameSpan);
	tr.appendChild(nametd);

	var hottd = document.createElement("td");
	var hotSpan = document.createElement("span");
	if(Consultant.nrank) {
		if(Consultant.nrank == "1") {
			hotSpan.setAttribute('class', 'hot-1 hot');
		} else if(Consultant.nrank == "2") {
			hotSpan.setAttribute('class', 'hot-2 hot');
		} else if(Consultant.nrank == "3") {
			hotSpan.setAttribute('class', 'hot-3 hot');
		}
		hotSpan.innerHTML = Consultant.nrank;
	} else {
		hotSpan.innerHTML = '无';
	}
	hottd.appendChild(hotSpan);
	tr.appendChild(hottd);

	var ordertd = document.createElement("td");
	var orderSpan = document.createElement("span");
	if(Consultant.status == '0') {
		orderSpan.setAttribute('class', 'can-order');
		orderSpan.innerHTML = '可约';
	} else  if(Consultant.status == '1'){
		orderSpan.setAttribute('class', 'cannot-order');
		orderSpan.innerHTML = '已满';
	}else{
		orderSpan.setAttribute('class', 'cannot-order');
		orderSpan.innerHTML = '休息';
	}
	ordertd.appendChild(orderSpan);
	tr.appendChild(ordertd);
	maskbody.appendChild(tr);

	tr.addEventListener("tap", function() {

		var index = this.getAttribute('value');
		if(customerConsultantList[index].status == '0') {
			mSelectConsultantId = customerConsultantList[index].npsnid;
			//			var sale = document.getElementById('sale');
			//			sale.innerHTML = customerConsultantList[index].vpsnname;
			var consultantName = document.getElementById('consultantName');
			var sexSpan = document.getElementById('sexSpan');
			//			sexSpan.style.display = 'block';
			consultantName.innerHTML = customerConsultantList[index].vpsnname;
			if(customerConsultantList[index].vSex == "1") {
				sexSpan.Class = 'avt man';
			} else {
				sexSpan.Class = 'avt woman';
			}

			onCloseShow();
		} else {
			plus.nativeUI.toast("您选择的顾问处在休息中!");
		}
	});
}

function onCloseShow() {
	console.log("onCloseShow");
	saleMask.close();
}

function showPersonMask() {
	personMask.show();
	mui('#sale_box')[0].style.display = 'block';
}

function onSearchUnlimitClick() {
	changeSearchState(1);
	createMaskUI(1, '');
}

function changeSearchState(limit) {
	var searchUnlimit = document.getElementById('searchUnlimit');
	var searchLast = document.getElementById('searchLast');
	var searchlimitlast = document.getElementById('searchlimitlast');
	switch(limit) {
		case 1:
			{
				searchUnlimit.setAttribute('class', 'item active');
				searchLast.setAttribute('class', 'item');
				searchlimitlast.setAttribute('class', 'item');
			}
			break;
		case 2:
			{
				searchUnlimit.setAttribute('class', 'item');
				searchLast.setAttribute('class', 'item active');
				searchlimitlast.setAttribute('class', 'item');
			}
			break;
		case 3:
			{
				searchUnlimit.setAttribute('class', 'item');
				searchLast.setAttribute('class', 'item');
				searchlimitlast.setAttribute('class', 'item active');
			}
			break;
	}

}

function onSearchClick() {
	var searchInput = document.getElementById('searchInput');
	createMaskUI(1, searchInput.value);
}

function onSearchLastClick() {
	changeSearchState(2);
	createMaskUI(2, "");
}

function onSearchlimitlastClick() {
	changeSearchState(3);
	createMaskUI(3, "");
}

function onSureClick() {
	var vehicleId = defaultCar.nVehicleId;
	var branchId = mBranch.nBID;
	var dateTime = selectTime;
	var consultantId = ""
	if(pindex)
		consultantId = mBranch.ConsultantList[pindex].npsnid;
	if(mConsultant)
		consultantId = mConsultant.npsnid;
	if(mSelectConsultantId)
		consultantId = mSelectConsultantId;
	var pkg = defaultMaintenancePkgInfo.pkgInfo.vpkg;
	var pkgName = defaultMaintenancePkgInfo.pkgInfo.vpkgname;
	var timeId = mBranch.SubscribeTime[subscribeIndex].nTimeID;
	var content = document.getElementById('content');

	var param = {
		"vehicleId": vehicleId,
		"branchId": branchId,
		"dateTime": Number(dateTime),
		"consultantId": consultantId,
		"pkg": pkg,
		"pkgName": pkgName,
		"timeId": timeId,
		"desc": content.value
	};
	var params = {
		"url": getIpAndPort() + "subscribe/confirmSubscribe.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting("处理中，请稍等");
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {

			if(response.code == 0) {
				var result = response.result;
				mui.openWindow({
					url: 'appointmentSuccess.html',
					id: 'page/appointmentSuccess.html',
					styles: {
						top: '0px',
						bottom: '0px'
					}, //窗口参数
					createNew:true,
					extras: {
						orderID: result,
						isShowBack: 0
					} //自定义扩展参数
				});
			} else {

				var tip = response.message;
				plus.nativeUI.toast(tip);

				//				goHome();
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//BR_TWS0145 获取服务顾问列表 预约确认时切换服务顾问，获取网点所有可用服务顾问列表
function getCustomerConsultantList() {
	var param = {
		"branchId": mBranch.nBID,
		"subDate": selectTime
	};
	var params = {
		"url": getIpAndPort() + "subscribe/customerConsultantList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				customerConsultantList = response.result;
				createMaskUI(1, "");
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取网点数据失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}