var defaultCar, mCarsList;
var curr;
var changeMileMask, selectCarMask;
var defaultMaintenancePkgInfo;
var seleteState = "0";
mui.init({
	"StatusBarBackground": "#4A4A4A",
	beforeback: function() {
		refreshMain();
		//返回true，继续页面关闭逻辑
		return true;
	}
});
mui.plusReady(function() {
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	defaultCar = curr.defaultCar;
	mCarsList = curr.CarsList;
	seleteState = "0";
	var lbLise = document.getElementById('lbLise');
	lbLise.innerHTML = defaultCar.vLicense;
	mui(document).on('tap', '#editKM', function(e) {
		showChangeMileMask();
	});
	createShowCarListView();
	initMask();

	plus.nativeUI.showWaiting();
	getDefaultMaintenancePkgInfo();
});

function refreshMain() {
	var main = plus.webview.getWebviewById('HBuilder');
	//	plus.webview.getWebviewById('mine.html').show();
	//触发列表界面的自定义事件（refresh）,从而进行数据刷新
	mui.fire(main, 'reloadpage', {
		id: 'home.html'
	});

}

function goHomeBack() {
	mui.currentWebview.close();
}

function initMask() {

	var lbDefaultCarType = document.getElementById('lbDefaultCarType');
	var lbchangeMile = document.getElementById('lbchangeMile');
	var lastInputMile = document.getElementById('lastInputMile');
	lbDefaultCarType.innerHTML = defaultCar.vSeriesName + defaultCar.vTypeName;
	lbchangeMile.innerHTML = defaultCar.nMile + "km";
	lastInputMile.value = defaultCar.nMile;
	var carlog = document.getElementById('carlog');
	carlog.src = getIp() + "asset/" + defaultCar.vbrand + ".png"
	changeMileMask = mui.createMask(function() {
		mui('#changeMile_box')[0].style.display = 'none'
	}); //callback为用户点击蒙版时自动执行的回调；

	selectCarMask = mui.createMask(function() {
		mui('#carlist_box')[0].style.display = 'none'
	}); //callback为用户点击蒙版时自动执行的回调；

	mui(".mui-table-view").on('tap', '.mui-table-view-cell', function() {
		//获取id
		var id = this.getAttribute("value");
		//传值给详情页面，通知加载新数据
		selectCarMask.close();
		defaultCar = mCarsList[id];
		var lbLise = document.getElementById('lbLise');
		lbLise.innerHTML = defaultCar.vLicense;

		initMask();
		getDefaultMaintenancePkgInfo();
	})
}

function showChangeMileMask() {
	changeMileMask.show(); //显示遮罩
	showSoftInput('nowInputMile');
	mui('#changeMile_box')[0].style.display = 'block'
}

function showSoftInput(eId) {
	var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
	if(mui.os.android) {
		//强制当前webview获得焦点
		plus.android.importClass(nativeWebview);
		nativeWebview.requestFocus();
		var Context = plus.android.importClass("android.content.Context");
		var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
		var main = plus.android.runtimeMainActivity();
		var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
	} else {
		nativeWebview.plusCallMethod({
			"setKeyboardDisplayRequiresUserAction": false
		});
	}
	var nowInputMile = document.getElementById(eId);
	nowInputMile.focus();
};

function closeChangeMileMask() {
	changeMileMask.close();
	var nowInputMile = document.getElementById('nowInputMile');
	if(nowInputMile.value > 0) {
		uploadLastChangeMile(nowInputMile.value);
	}
}

function showCarListMask() {
	selectCarMask.show();
	mui('#carlist_box')[0].style.display = 'block'
}

function onCloseShow() {
	selectCarMask.close();
}

//创建车辆选择弹出框中的列表
function createShowCarListView() {

	if(mCarsList != null && mCarsList.length > 0) {
		mui.each(mCarsList, function(index, item) {
			createTablieli(index, item.vLicense, item.vCusName,
				item.vMobile, item.vSeriesName, item.vLinkMan, item.vPhone);
		})
	}
}

function createTablieli(index, vLicense, customName, customPhone, carType, contactName, contactPhone) {
	var tableviewCarlist = document.getElementById('tableviewCarlist');
	var div = document.createElement("li");
	div.className = "mui-table-view-cell mui-media";
	div.value = index;
	if(contactName == null)
		contactName = "暂无";
	if(contactPhone == null)
		contactPhone = '暂无';

	var str = '<div class="mui-media-body">  ' +
		'<table class="cartable">' +
		'<tr >' +
		'<td >' +
		'<span class="sale-avt women"></span>' +
		'<span>' + vLicense + '</span>' +
		'</td>' +
		'<td >' +
		'<span class="hot-1 hot">客户：</span>' +
		'<span class="hot-1 hot">' + customName + '</span>' +
		'</td>' +
		'<td >' +
		'	<span class="can-order">客户电话:' + customPhone + '</span>' +
		'</td>' +
		'</tr>' +
		'<tr>' +
		'<td >' +
		'<span class="sale-avt women"></span>' +
		'<span>' + carType + '</span>' +
		'</td>' +
		'<td >' +
		'	<span class="hot-1 hot">联系人：</span>' +
		'	<span class="hot-1 hot">' + contactName + '</span>' +
		'</td>' +
		'<td >' +
		'<span class="can-order">联系人电话:' + contactPhone + '</span>' +
		'</td>' +
		'</tr>' +
		'</table>' +
		'</div>';

	div.innerHTML = str;

	tableviewCarlist.appendChild(div);
}

function onSelectCarClick() {
	var $checkboxOneInput = document.getElementById("checkboxOneInput");
	plus.nativeUI.showWaiting();
	if($checkboxOneInput.checked) {
		seleteState = "1";
	} else {
		seleteState = "0";
	}
	getDefaultMaintenancePkgInfo();
}

//BR_TWS0040 更新行驶里程 更新客户车辆当前行驶里程；
function uploadLastChangeMile(lastMile) {
	var param = {
		"vehicleId": defaultCar.nVehicleId,
		"mile": lastMile
	};
	var params = {
		"url": getIpAndPort() + "vehicle/updateMile.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('更新行驶里程中...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
//		curr.show();
		if(response != null) {
			if(response.code == 0) {
				var lbchangeMile = document.getElementById('lbchangeMile');
				lbchangeMile.innerHTML = lastMile + "km";

				//				var lbchangeMileTime = document.getElementById('lbchangeMileTime');
				//				var datenow = new Date();
				//				lbchangeMileTime.innerHTML = datenow.getFullYear() + '/' + datenow.getMonth() + '/' + datenow.getDay();
			} else {
				var tip = response.message;

				plus.nativeUI.toast(tip);

			}
		} else {
			plus.nativeUI.toast("更新数据失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
//		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function onGoHelp() {
	mui.openWindow({
		url: 'manual.html',
		id: 'page/manual.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			defaultCar: defaultCar
		}
	});
}
//BR_TWS0081 获取车辆上次里程修改时间 获取车辆上一次里程的修改时间；
function getLastMileUpdate() {
	var param = {
		"vehicleId": defaultCar.nVehicleId
	};
	var params = {
		"url": getIpAndPort() + "vehicle/lastMileUpdate.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
//		curr.show();
		if(response != null) {
			if(response.code == 0) {
				if(response.result) {
					var updateDate = new Date(response.result);
					var nowDate = new Date();

					var distime = (nowDate.getTime() - updateDate.getTime()) / 1000 / 60 / 60 / 24;

					if(distime > 1) {
						var btnArray = ['修改', '取消'];

						mui.confirm('上次修改里程时间已经超过一天，是否修改?', '提示', btnArray, function(e) {
							if(e.index == 0) {
								showChangeMileMask();
							}
						});
					}
				}
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
//		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//BR_TWS0080 获取车辆默认保养套餐 按车辆及行驶里程获取当前推荐保养套餐；
function getDefaultMaintenancePkgInfo() {
	var param = {
		"vehicleId": defaultCar.nVehicleId,
		"selete": seleteState
	};
	var params = {
		"url": getIpAndPort() + "vehicle/defaultMaintenancePkgInfo.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
//		curr.show();
		if(response) {

			if(response.code == 0) {

				if(response.result && response.result.materialOff) {
					getLastMileUpdate();
					defaultMaintenancePkgInfo = response.result;
					createProductlist();
				} else {

					goHomeBack();
					plus.nativeUI.toast("当前无保养信息!");

				}
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
				goHomeBack();
			}
		} else {
			plus.nativeUI.toast("请求失败!");
			goHomeBack();
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
//		curr.show();
		plus.nativeUI.toast("请求失败!");
		goHomeBack();
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

//创建材料清单列表
function createProductlist() {
	var maintenanceName = document.getElementById('maintenanceName');
	maintenanceName.innerHTML = defaultMaintenancePkgInfo.pkgInfo.vpkgname.substring(0, 15) + '...';
	var productNum = document.getElementById('productNum');
	productNum.innerHTML = "共" + defaultMaintenancePkgInfo.materialList.length + "件";
	var materialOff = document.getElementById('materialOff');
	if(defaultMaintenancePkgInfo.materialOff == 0) {
		materialOff.innerHTML = "材料免费"
	} else if(defaultMaintenancePkgInfo.materialOff == 1) {
		materialOff.style.display = "none";
	} else {
		materialOff.innerHTML = '材料' + defaultMaintenancePkgInfo.materialOff * 10 + "折";
	}
	var materialIOriginalPrice = document.getElementById('materialIOriginalPrice');
	var materialIDiscountPrice = document.getElementById('materialIDiscountPrice');
	materialIOriginalPrice.innerHTML = "¥" + defaultMaintenancePkgInfo.material;
	materialIDiscountPrice.innerHTML = "¥" + defaultMaintenancePkgInfo.materialDis;

	var workOriginalPrice = document.getElementById('workOriginalPrice');
	var workDiscountPrice = document.getElementById('workDiscountPrice');
	workOriginalPrice.innerHTML = "¥" + defaultMaintenancePkgInfo.workhour;
	workDiscountPrice.innerHTML = "¥" + defaultMaintenancePkgInfo.workhourDis;
	var workOff = document.getElementById('workOff');
	if(defaultMaintenancePkgInfo.workhourOff == 1) {
		workOff.innerHTML = "工时费无优惠";
		workOff.style.display = "none";
	} else if(defaultMaintenancePkgInfo.workhourOff == 0) {
		workOff.innerHTML = "工时费免费";
	} else {
		workOff.innerHTML = "工时费享" + defaultMaintenancePkgInfo.workhourOff * 10 + "折优惠";
	}
	var totlePrice = document.getElementById('totlePrice');
	totlePrice.innerHTML = defaultMaintenancePkgInfo.totalDis;
	var totleDiscountPrice = document.getElementById('totleDiscountPrice');
	var totleOriginalPrice = document.getElementById('totleOriginalPrice');
	var price = defaultMaintenancePkgInfo.total - defaultMaintenancePkgInfo.totalDis;

	totleDiscountPrice.innerHTML = price.toFixed(2);
	totleOriginalPrice.innerHTML = defaultMaintenancePkgInfo.total;

	var tableviewCarlist = document.getElementById('productList');
	while(tableviewCarlist.hasChildNodes()) //当div下还存在子节点时 循环继续
	{
		tableviewCarlist.removeChild(tableviewCarlist.firstChild);
	}
	mui.each(defaultMaintenancePkgInfo.materialList, function(index, item) {
		createProduct(item.vspaname, item.dis, item.nprice);
	})
}

function createProduct(productName, productDicPrice, productPrice) {
	var tableviewCarlist = document.getElementById('productList');
	var div = document.createElement("li");
	div.className = "mui-clearfix";

	var str = '<div class="product-name"> ' +
		'<span class="yd-checkbox checked"></span>' +
		'<span id="productName" class="title">' + productName + '</span>' +
		'</div>' +
		'<div class="pruduct-price">' +
		'	<span id="productPrice" class="discount-price">¥' + productPrice.toFixed(2) + '</span>' +
		'	<span id="productDicPrice" class="now-price">¥' + productDicPrice.toFixed(2) + '</span>' +
		'</div>';
	div.innerHTML = str;

	tableviewCarlist.appendChild(div);
}

function onNextClick() {
	mui.openWindow({
		url: 'appointmentSelectTime.html',
		id: 'page/appointmentSelectTime.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		createNew: true,
		extras: {
			defaultMaintenancePkgInfo: defaultMaintenancePkgInfo,
			defaultCar: defaultCar
		} //自定义扩展参数
	});
}