(function() {
	var curr
	mui.init()
	mui.plusReady(function() {
		curr = plus.webview.currentWebview()

		var app = new Vue({
			el: '#app',
			data: {
				defaultCar: {},
				handbooks: [],
				itemTitles: {},
				checkedIn: -1,
				logoPath: ''
			},
			mounted: function() {
				this.defaultCar = curr.defaultCar
				this.logoPath = getIp() + "asset/" + curr.defaultCar.vbrand + ".png" 
				this.getData()
				
//				document.getElementById('food_detail').ontouchmove = function(e) { e.preventDefault()}
			},
			methods: {
				getData: function() {
					var self = this
					plus.nativeUI.showWaiting('正在获取保养手册...');

					ajaxunit({
						"url": getIpAndPort() + "vehicle/maintenanceBook.do",
						"method": "post",
						"pa": {
							vehicleTypeId: curr.defaultCar.nTypeId
						}
					}, function(data) {
						var result = data.result
						if (result.length) {
							self.handbooks = result
						}
						plus.nativeUI.closeWaiting();
//						self.handbook.dTstamp = timestampformat(self.handbook.dTstamp, 'yyyy年MM月')
						
						var itemTitles = {}
						self.handbooks.forEach(function(handbook) {
							handbook.item.forEach(function(item) {
								itemTitles[item.vspa] = item.vspaname
							})
						})
						self.itemTitles = itemTitles
						self.getCheckedIndex()
						console.log(JSON.stringify(itemTitles))
						console.log(JSON.stringify(result))
					});
				},
				checkedInFn: function(handbook, key) {
					var hasItem = false
					handbook.item.forEach(function(val) {
						if (val.vspa === key) {
							hasItem = true
						}
					})
					return hasItem
				},
				getCheckedIndex: function() {
					var nMile = this.defaultCar.nMile * 1
					var vMonth = this.defaultCar.vMonth * 1
					var checked = false 
					var self = this
					this.handbooks.forEach(function(handbook, index) {
						if (checked) {
							return
						}

						if(handbook.nMile * 1 >= nMile || handbook.vMonth * 1 >= vMonth) {
							self.checkedIn = index
							checked = true
						}
					})
					console.log(this.checkedIn)
				}
			}
		})

		
		
	})
})()