var navTitle;
var mainWebview;
var curBarItemWebview;
var barItemWebviewArray = [];
var subpages = ['home.html', 'mine.html'];
var user;
var wgtVer = null;

var subpage_style = {
	top: '44px',
	bottom: '51px',
	left: '0px',
	bounce: 'vertical',
	bounceBackground: '#f8f8f8'
};
var aniShow = {};
mui.init({
	swipeBack: true
});
mui.plusReady(function() {
	//	plus.nativeUI.showWaiting()

	//获取当前title和当前webview
	navTitle = document.querySelector('.mui-title');
	mainWebview = plus.webview.currentWebview();

	plus.navigator.setStatusBarBackground("#59A3FC");
	user = JSON.parse(localStorage.getItem('user'));
	//设置只支持竖屏幕显示
	plus.screen.lockOrientation("portrait-primary");
	//初始化与index有关的页面
	initIndexView();
	document.addEventListener("resume", function() {
		reloadPage();
	}, false);
	addReloadPageEvent();
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version;
	});

	checkUpdate();

//	plus.push.addEventListener("receive", function(msg) {
//
//		var data = JSON.parse(msg.payload);
//		alert(JSON.stringify(msg))
//		alert(data.pushMsg)
//		//创建本地消息
//		plus.push.createMessage('data.pushMsg', "LocalMSG", {
//			cover: false
//		});
//	}, false);
});

//初始化
function initIndexView() {
	//初始化所有bar页面
	inittabitemWebviews();
	//添加bar点击事件接受
	tapBaritem();
}
//初始化所有bar页面
function inittabitemWebviews() {

	var self = plus.webview.currentWebview();
	for(var i = 0; i < 2; i++) {
		var temp = {};
		var sub = plus.webview.create(subpages[i], subpages[i], subpage_style);
		if(i > 0) {
			sub.hide();
		} else {
			temp[subpages[i]] = "true";
			mui.extend(aniShow, temp);
		}
		self.append(sub);
	}
}
var activeTab = subpages[0];

//setInterval(function() {
//	var muiTabItems = mui('.mui-bar-tab .mui-tab-item')
//	muiTabItems.each(function() {
//		var href = this.getAttribute('href');
//		var pageView = plus.webview.getWebviewById(href);
//		if(this.className.indexOf('mui-active') > -1) {
//			console.log(href)
//			plus.webview.show(pageView);
//		}else{
//			plus.webview.hide(pageView);
//		}
//	})
//}, 1000)

//添加点击事件
function tapBaritem() {
	var muiTabItems = mui('.mui-bar-tab .mui-tab-item')

	mui('.mui-bar-tab').on('tap', '.mui-tab-item', function() {
		var self = this

		if(this.className.indexOf('mui-active') > -1) {
			return
		}

		var targetTab = self.getAttribute('href');

		var pageView = plus.webview.getWebviewById(targetTab);

		mui.fire(pageView, 'reloadpage', {
			//			id: id
		});

		if(targetTab == activeTab) {
			return;
		}

		//更换标题
		navTitle.innerHTML = self.querySelector('.mui-tab-label').innerHTML;
		//显示目标选项卡
		//若为iOS平台或非首次显示，则直接显示
		if(mui.os.ios || aniShow[targetTab]) {
			plus.webview.show(targetTab);
		} else {
			//否则，使用fade-in动画，且保存变量
			var temp = {};
			temp[targetTab] = "true";
			mui.extend(aniShow, temp);
			plus.webview.show(targetTab, "fade-in", 300);
		}
		//隐藏当前;
		plus.webview.hide(activeTab);
		//更改当前活跃的选项卡
		activeTab = targetTab;

	});
}

function loginButtonClick() {
	mui.openWindow({
		url: 'page/login.html',
		id: 'login.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {} //自定义扩展参数
	});
}
//添加监听事件
function addReloadPageEvent() {
	window.addEventListener('reloadpage', function(options) {
		reloadPage();
	});
}

function reloadPage() {
	var pageView = plus.webview.getWebviewById(activeTab);
	console.log("main load:" + activeTab)
	mui.fire(pageView, 'reloadpage', {});
}

function checkUpdate() {
	var param = {};
	var params = {
		"url": getIp() + "asset/version.json",
		"method": "get",
		"pa": param
	};
	var successcallback = function(response) {
		if(response) {
			var version = response.verson;
//			alert(getIp() + "asset/version.json"+"::::::"+version)
			if(wgtVer && version && (version != wgtVer)) {
				downWgt(response.downpath);
			}
		}
		getCarTypeDic();
	};
	var failurecallback = function(xhr, opts) {
		getCarTypeDic();
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function downWgt(path) {
	plus.nativeUI.showWaiting("下载更新文件...");
	plus.downloader.createDownload(path, {
		filename: "_doc/update/"
	}, function(d, status) {
		if(status == 200) {
			installWgt(d.filename); // 安装wgt包
		} else {
			plus.nativeUI.alert("下载失败！");
		}
		plus.nativeUI.closeWaiting();
	}).start();
}
// 更新应用资源
function installWgt(path) {
	plus.nativeUI.showWaiting("安装更新文件...");
	plus.runtime.install(path, {}, function() {
		plus.nativeUI.closeWaiting();
		console.log("安装更新文件成功！");
		plus.nativeUI.alert("新版本更新完成！", function() {
			plus.runtime.restart();
		});
	}, function(e) {
		plus.nativeUI.closeWaiting();
		console.log("安装更新文件失败[" + e.code + "]：" + e.message);
		plus.nativeUI.alert("安装更新文件失败[" + e.code + "]：" + e.message);
	});
}

function getPrecision() {
	var param = {
		"paramCode": PRECISION
	};
	var params = {
		"url": getIp() + "generic/dic/param.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var defaultLicense = response.result;
				localStorage.setItem(PRECISION, defaultLicense);

			}
		}
	};
	var failurecallback = function(xhr, opts) {

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getDefaultLicenseDic() {

	var param = {
		"paramCode": DEFAULTLICENSE
	};
	var params = {
		"url": getIp() + "generic/dic/param.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var defaultLicense = response.result;
				localStorage.setItem(DEFAULTLICENSE, defaultLicense);

			}
		}
			getPrecision();
	};
	var failurecallback = function(xhr, opts) {
		getPrecision();
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getBookingStatusDic() {
	var param = {
		"dicId": BOOKINGSTATUS
	};
	var params = {
		"url": getIp() + "generic/dic/get.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var bookingStatusDic = response.result.items;
				localStorage.setItem(BOOKINGSTATUS, JSON.stringify(bookingStatusDic));

			}
		}
		getDefaultLicenseDic();
	};
	var failurecallback = function(xhr, opts) {
		getDefaultLicenseDic();
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getPayStatusDic() {
	var param = {
		"dicId": PAYSTATUS
	};
	var params = {
		"url": getIp() + "generic/dic/get.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var payStatusDic = response.result.items;
				localStorage.setItem(PAYSTATUS, JSON.stringify(payStatusDic));

			}
		}
		getBookingStatusDic();
	};
	var failurecallback = function(xhr, opts) {
		getBookingStatusDic();
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getCarTypeDic() {
	var param = {};
	var params = {
		"url": getIp() + "generic/dic/vehicleMetadata.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var carTypeDic = formatCarTypeData(response.result);
				localStorage.setItem("carTypeDic", JSON.stringify(carTypeDic));

			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			//			plus.nativeUI.toast("请求车辆品牌失败!");
		}
		getPayStatusDic();
	};
	var failurecallback = function(xhr, opts) {
		getPayStatusDic();
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}