var navTitle;
var mainWebview;
var curBarItemWebview;
var barItemWebviewArray = [];
var barItemArray = ['home.html', 'mine.html'];
var user;
mui.init({
	swipeBack: true
});

mui.plusReady(function() {
	plus.nativeUI.showWaiting()
	
	//获取当前title和当前webview
	navTitle = document.querySelector('.mui-title');
	mainWebview = plus.webview.currentWebview();

	plus.navigator.setStatusBarBackground("#59A3FC");
	user = JSON.parse(localStorage.getItem('user'));
	//设置只支持竖屏幕显示
	plus.screen.lockOrientation("portrait-primary");
	//初始化与index有关的页面
	initIndexView();
	//检测是否需要显示导航页面todo

	//预加载父子模版
//	initTemplate();

	judgelogin();
	addReloadPageEvent();
	getCarTypeDic();
	getPayStatusDic();
	getBookingStatusDic();
	getDefaultLicenseDic();
	getPrecision();
});

function getPrecision(){
	var param = {
		"paramCode": PRECISION
	};
	var params = {
		"url": getIp() + "generic/dic/param.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var defaultLicense = response.result;
				localStorage.setItem(PRECISION, defaultLicense);

			} 
		} 
	};
	var failurecallback = function(xhr, opts) {

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getDefaultLicenseDic(){
	
	var param = {
		"paramCode": DEFAULTLICENSE
	};
	var params = {
		"url": getIp() + "generic/dic/param.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var defaultLicense = response.result;
				localStorage.setItem(DEFAULTLICENSE, defaultLicense);

			} 
		} 
	};
	var failurecallback = function(xhr, opts) {

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
function getBookingStatusDic(){
	var param = {
		"dicId":BOOKINGSTATUS
	};
	var params = {
		"url": getIp() + "generic/dic/get.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var bookingStatusDic = response.result.items;
				localStorage.setItem(BOOKINGSTATUS, JSON.stringify(bookingStatusDic));

			} 
		} 
	};
	var failurecallback = function(xhr, opts) {

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
function getPayStatusDic(){
	var param = {
		"dicId":PAYSTATUS
	};
	var params = {
		"url": getIp() + "generic/dic/get.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var payStatusDic = response.result.items;
				localStorage.setItem(PAYSTATUS, JSON.stringify(payStatusDic));

			} 
		} 
	};
	var failurecallback = function(xhr, opts) {

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getCarTypeDic() {
	var param = {};
	var params = {
		"url": getIp() + "generic/dic/vehicleMetadata.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {

		if(response != null) {
			if(response.code == 0) {
				var carTypeDic = formatCarTypeData(response.result);
				localStorage.setItem("carTypeDic", JSON.stringify(carTypeDic));

			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			//			plus.nativeUI.toast("请求车辆品牌失败!");
		}

	};
	var failurecallback = function(xhr, opts) {

	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//初始化
function initIndexView() {
	//初始化所有bar页面
	inittabitemWebviews();
	//添加bar点击事件接受
	tapBaritem();
}
//初始化所有bar页面
function inittabitemWebviews() {
	for(var i = 0; i < barItemArray.length; i++) {
		barItemWebviewArray[i] = mui.preload({
			id: barItemArray[i],
			url: barItemArray[i],
			styles: {
				top: '44px',
				bottom: '51px',
				left: '0px',
				bounce: 'vertical',
				bounceBackground: '#f8f8f8'
			},
			waiting: {
				autoShow: true
			}
		});
		barItemWebviewArray[i].hide();
		mainWebview.append(barItemWebviewArray[i]);
	}
	
	barItemWebviewArray[1].hide()
	barItemWebviewArray[0].show();
	curBarItemWebview = barItemWebviewArray[0];
}

//添加点击事件
function tapBaritem() {
	mui('.mui-bar-tab').on('tap', '.mui-tab-item', function() {

		var baritem = this;
		var baritemurl = baritem.getAttribute('href');
		//				indexof()如果为false返回－1所以前面加上~
		if(!~curBarItemWebview.getURL().indexOf(baritemurl)) {
			for(var i = 0; i < barItemArray.length; i++) {
				if(barItemArray[i] == baritemurl) {
					//更改头部名字
					navTitle.innerText = baritem.children[baritem.children.length - 1].innerText;
					//切换baritemwebview
					barItemWebviewArray[i].show();
					curBarItemWebview = barItemWebviewArray[i];

					var pageView = plus.webview.getWebviewById(barItemArray[i]);
					mui.fire(pageView, 'reloadpage', {
						//						id: id
					});
					break;
				} else {
					barItemWebviewArray[i].hide();
				}
			}
		}
	});
}

//预加载template
function initTemplate() {
	var webview = mui.preload({
		id: 'template',
		url: 'template.html',
		styles: {
			top: '-1000px',
		}
	});
	webview.show();
};

function myLoginIconShow(isShow) {
	if(isShow == 1) {
		//显示
//		document.getElementById("btnLogin").style.display = "block";
	} else {
		//隐藏
//		document.getElementById("btnLogin").style.display = "none";
	}
}

function judgelogin() {
	//判断是否已经登录成功
	if(!user) {
		myLoginIconShow(1);
	} else {
		myLoginIconShow(0);
	}
}

function loginButtonClick() {
	mui.openWindow({
		url: 'page/login.html',
		id: 'login.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {} //自定义扩展参数
	});
}
//添加监听事件
function addReloadPageEvent() {
	window.addEventListener('reloadpage', function(options) {
//		var id = options.detail.id;
//		var myPage = plus.webview.getWebviewById('mine.html');
//		var homePage = plus.webview.getWebviewById('home.html');
//		user = JSON.parse(localStorage.getItem('user'));
////		judgelogin()
//		var tabs = document.querySelectorAll('.mui-tab-item')
//		for (var i = 0,l = tabs.length;i<l;i++) {
//			var href = tabs[i].getAttribute('href')
//			if (href === id) {
//				tabs[i].className = 'mui-tab-item mui-active'
//			} else {
//				tabs[i].className = 'mui-tab-item'
//			}
//		}
//		
//		curBarItemWebview = plus.webview.getWebviewById(id)
		var minPageView = plus.webview.getWebviewById('mine.html');
					mui.fire(minPageView, 'reloadpage', {
						//						id: id
					});
		var homePageView = plus.webview.getWebviewById('home.html');
		mui.fire(homePageView, 'reloadpage', {
						//						id: id
					});
		curBarItemWebview.show()
		mui.fire(curBarItemWebview, 'reloadpage')
	});
}