var curr;
var user = null;
mui.init();
mui.plusReady(function() {
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	initUI();
	user = JSON.parse(localStorage.getItem('user'));

	var cellCoupon = document.getElementById('cellCoupon');
	cellCoupon.addEventListener('tap', onCellCouponClick);

	var cellConcat = document.getElementById('cellConcat');
	cellConcat.addEventListener('tap', onCellConcatClick);
	var cellMyCar = document.getElementById('cellMyCar');
	cellMyCar.addEventListener('tap', onCellMyCarClick);
	var cellCustomerCar = document.getElementById('cellCustomerCar');
	cellCustomerCar.addEventListener('tap', onCellCustomerCarClick);

	var cellCalandar = document.getElementById('cellCalandar');
	cellCalandar.addEventListener('tap', onCellCalandarClick);

	document.getElementById('setting').addEventListener('tap', onSettingClick)
	document.getElementById('touxiangimg').addEventListener('tap', onHeadImgClick)

	var waitApproachBg = document.getElementById('waitApproachBg');
	var fixingBadge = document.getElementById('fixingBadge');
	waitApproachBg.style.display = "none";
	fixingBadge.style.display = "none";
	addReloadPageEvent();
	
//	document.ontouchmove = function(e) {
//		e.preventDefault()
//	}
	
//	document.ontouchmove = function(e) {
//		console.log(e.target)
//		e.preventDefault()
//	}
//	
//	document.body.ontouchmove = function(e) {
//		e.stopImmediatePropagation()
//	}
});

function initUI() {
	var lb_username = document.getElementById('lb_username');
	var lb_member = document.getElementById('lb_member');
	user = JSON.parse(localStorage.getItem('user'));
	
	if(!user) {
		lb_member.style.display = "none";
		lb_username.innerHTML = "请登录";

		var waitApproachBg = document.getElementById('waitApproachBg');
		var fixingBadge = document.getElementById('fixingBadge');
		waitApproachBg.style.display = "none";
		fixingBadge.style.display = "none";
		var myticktNum = document.getElementById('myticktNum');
		myticktNum.innerHTML = 0;
		mui('#Avatar')[0].src = ''

	} else {
		lb_member.style.display = "block";
		if(user.cusName)
			lb_username.innerHTML = user.cusName;
		else
			lb_username.innerHTML = user.account;
		getMyinfo();
		getCustomerCouponCount();
		getAvatarAddr();
	}
}
//刷新主界面
function addReloadPageEvent() {
	window.addEventListener('reloadpage', function(event) {
		console.log("mine:reloadpage");
		initUI();
	});
}

//我的预约
function onCellCalandarClick() {
	mui.openWindow({
		url: 'page/myAppointment.html',
		id: 'page/myAppointment.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		createNew:true,
		extras: {
			status: ""
		} //自定义扩展参数
	});
}

//点击我的联系人
function onCellConcatClick() {
	mui.openWindow({
		url: 'page/myContacts.html',
		id: 'page/myContacts.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			//			code: vercode.value,
			//			mobile: account.value
		} //自定义扩展参数
	});
}
function onwaitApproachClick(){
	mui.openWindow({
		url: 'page/myAppointment.html',
		id: 'page/myAppointment.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			status: 0
		} //自定义扩展参数
	});
}
function onfixingClick(){
	mui.openWindow({
		url: 'page/myAppointment.html',
		id: 'page/myAppointment.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			status: 1
		} //自定义扩展参数
	});
}
//点击我的车辆
function onCellMyCarClick() {
	mui.openWindow({
		url: 'page/myCars.html',
		id: 'page/myCars.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			//			code: vercode.value,
			//			mobile: account.value
		} //自定义扩展参数
	});
}
//点击客户车辆
function onCellCustomerCarClick() {
	mui.openWindow({
		url: 'page/customerCar.html',
		id: 'page/customerCar.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			//			code: vercode.value,
			//			mobile: account.value
		} //自定义扩展参数
	});
}
//点击代金券
function onCellCouponClick() {
	mui.openWindow({
		url: 'page/ticket.html',
		id: 'page/ticket.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			//			code: vercode.value,
			//			mobile: account.value
		} //自定义扩展参数
	});
}
//获取当前代金券数量
function getCustomerCouponCount() {
	var param = {};
	var params = {
		"url": getIpAndPort() + "payment/couponCount.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		//		curr.show();
		if(response != null) {
			if(response.code == 0) {
				if(response.result) {
					var myticktNum = document.getElementById('myticktNum');
					myticktNum.innerHTML = response.result;
				}
			} else {
				var tip = response.message;

				plus.nativeUI.toast(tip);

			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		curr.show();
		plus.nativeUI.toast("获取数据失败，请检查网络！");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
//获取客户当前预约信息 获取客户当前预约单信息，包括待进厂、已进厂（维修中）的预约单数量
function getMyinfo() {
	var param = {};
	var params = {
		"url": getIpAndPort() + "subscribe/subscribeStatistics.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		//		curr.show();
		if(response != null) {
			if(response.code == 0) {
				if(response.result != null) {

					var waitApproachBg = document.getElementById('waitApproachBg');
					var fixingBadge = document.getElementById('fixingBadge');
					console.log("response.result.approachingCount:" + response.result.approachingCount)
					if(response.result.approachingCount > 0) {
						console.log("approachingCount1:")
						waitApproachBg.style.display = "block";
						waitApproachBg.innerHTML = response.result.approachingCount;
					} else {
						waitApproachBg.style.display = "none";
					}
					if(response.result.approachedCount > 0) {
						fixingBadge.innerHTML = response.result.approachedCount;
						fixingBadge.style.display = "block";
					} else {
						fixingBadge.style.display = "none";
					}

				}
			} else {
				var tip = response.message;

				plus.nativeUI.toast(tip);

			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		//		curr.show();
		plus.nativeUI.toast("获取数据失败，请检查网络！");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

//获取用户头像
function getAvatarAddr() {
	var Avatar = mui('#Avatar')[0]
//	Avatar.src = ''
	ajaxunit({
		"url": getIpAndPort() + "account/getAvatarAddr.do",
		"method": "post"
	}, function(data) {
		Avatar.src = getIp() + data.result + "?random=" + new Date().getTime()
	})
}

function onSettingClick(e) {
	e.stopImmediatePropagation()
	mui.openWindow({
		url: 'page/setting.html',
		id: 'page/setting.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			//			code: vercode.value,
			//			mobile: account.value
		} //自定义扩展参数
	});
}

function onHeadImgClick() {
	mui.openWindow({
		url: 'page/user_info.html',
		id: 'page/user_info.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		extras: {
			//			code: vercode.value,
			//			mobile: account.value
		} //自定义扩展参数
	});
}