var curr, contactListResult;
var isEditModel = false;
var addInputIndex = 0;
mui.init()
mui.plusReady(function() {
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	getMyContacts();
	
});
//界面添加联系人
function initContacts() {
	var divContactList = document.getElementById('divContactList');
	while(divContactList.hasChildNodes()) //当div下还存在子节点时 循环继续
	{
		divContactList.removeChild(divContactList.firstChild);
	}
	if(contactListResult != null&&contactListResult.length>0) {
		for(var i = 0; i < addInputIndex; i++) {
			crateDiv(i, contactListResult[i].nLinkManID,contactListResult[i].vLinkMan, contactListResult[i].vPhone);
		}
	}
}
//点击保存按钮，保存
function onSaveButtonClick() {
	if(isEditModel){
		addNewContacts();
	}else{
		saveEditContacts();	
	}	
}
//更新联系人信息
function saveEditContacts() {
	for(var i = 0; i < addInputIndex; i++) {
		var nameId = 'inputContactName' + i;
		var phoneId = 'inputContactPhone' + i;

		var inputName = document.getElementById(nameId);
		var inputPhone = document.getElementById(phoneId);
		if(inputName==null)
			break;
		if(inputName.value == null || inputName.value == "") {
			plus.nativeUI.toast("联系人姓名不能为空！");
			return;
		}
		if(inputPhone.value == null || inputPhone.value == "") {
			plus.nativeUI.toast("联系人手机号不能为空！");
			return;
		}
		if(inputPhone.value.trim().length!=11) {
			plus.nativeUI.toast("请输入正确的手机号！");
			return;
		}

		var param = {
			"linkManId":contactListResult[i].nLinkManID,
			"linkManName": inputName.value.trim(),
			"mobile": inputPhone.value.trim()
		};
		var params = {
			"url": getIpAndPort() + "account/updateLinkMan.do",
			"method": "post",
			"pa": param
		};
		plus.nativeUI.showWaiting("更新中...")
		var successcallback = function(response) {
			plus.nativeUI.closeWaiting();
			curr.show();
			if(response != null) {
				if(response.code == 0) {
					if(response.result != null) {
						contactListResult = response.result;
					} 

					if(i==addInputIndex)
						plus.nativeUI.toast(response.message);
				} else {
					var tip = response.message;

					plus.nativeUI.toast(tip);

				}
			} else {
				plus.nativeUI.toast("请求失败!");
			}

		};
		var failurecallback = function(xhr, opts) {
			plus.nativeUI.closeWaiting();
			curr.show();
			plus.nativeUI.toast("获取数据失败，请检查网络！");
		};

		if(checknetwork(true)) {
			ajaxunit(params, successcallback, failurecallback);
		}
	}
}
function isSamePhone(number){
	if(contactListResult){
		for(var i=0;i<contactListResult.length;i++){
			if(contactListResult[i].vPhone.trim()==number.trim()){
				return true;
			}
		}
		return false;
	}else{
		return false;
	}
}
function addNewContacts() {
	if(!isEditModel)
	return;
	var nameId = 'inputContactName' + addInputIndex;
	var phoneId = 'inputContactPhone' + addInputIndex;
	//新增
	var inputName = document.getElementById(nameId);
	var inputPhone = document.getElementById(phoneId);
	
	if(inputName.value == null || inputName.value == "") {
		plus.nativeUI.toast("联系人姓名不能为空！");
		return;
	}
	if(inputPhone.value == null || inputPhone.value == "") {
		plus.nativeUI.toast("联系人手机号不能为空！");
		return;
	}
	console.log('lenght:'+inputPhone.value.length);
	if(inputPhone.value.length!=11) {
		plus.nativeUI.toast("联系人手机号格式不对！");
		return;
	}
	
	if(isSamePhone(inputPhone.value)){
		plus.nativeUI.toast("输入的手机号与其它联系人手机号相同");
		return;
	}

	var param = {
		"linkManName": inputName.value.replace(/(^\s*)|(\s*$)/g, ""),
		"mobile": inputPhone.value.replace(/(^\s*)|(\s*$)/g, "")
	};
	var params = {
		"url": getIpAndPort() + "account/addLinkMan.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('正提交数据...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				isEditModel = false;
				if(response.result != null) {
					contactListResult = response.result;
					
				} 
				plus.nativeUI.toast(response.message);
			} else {
				var tip = response.message;

				plus.nativeUI.toast(tip);

			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("获取数据失败，请检查网络！");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

//获取我的联系人
function getMyContacts() {
	var param = {};
	var params = {
		"url": getIpAndPort() + "account/linkManList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				if(response.result != null) {
					contactListResult = response.result;
					addInputIndex = contactListResult.length;
					
					initContacts();
				} else {

				}
			} else {
				var tip = response.message;

				plus.nativeUI.toast(tip);

			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}

	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("获取数据失败，请检查网络！");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function btnAddClick() {
	if(!isEditModel) {

		addInputIndex = addInputIndex + 1;

		crateDiv(addInputIndex, "","", "");
		var inputNameId = "inputContactName" + addInputIndex;
		var inputName = document.getElementById(inputNameId);
		if(inputName){
			inputName.focus();
		}
		isEditModel = true;
	} else {
		plus.nativeUI.toast("当前已经是编辑模式，请先保存！");
	}
}

function crateDiv(index,linkManId,name, phone) {
	var divContactList = document.getElementById('divContactList');
	var div = document.createElement("div");
	div.id = 'child' + index;
	var inputNameId = "inputContactName" + index;
	var inputPhoneId = "inputContactPhone" + index;

	var str = '<div class="user-info" style="margin-top: 10px;"> ' +
		'<div class="item mui-clearfix"> ' +
		'<span class="title">联系人姓名</span> ' +
		'<span class="content"> ' +
		'<input id=' + inputNameId + ' type="text"  placeholder="请输入" class="yd-msg-input" value='+ name +'></input> ' +
		'</span></div><div class="item mui-clearfix"> ' +
		'<span class="title">联系人手机</span> ' +
		'<span class="content"> ' +
		'<input id='+ inputPhoneId +' type="text"  placeholder="请输入" class="yd-msg-input" value='+ phone + '></input> ' +
		'</span></div> ' +
		'<div class="item mui-clearfix"> ' +
		'			<a index =' + index + ' linkManId=' + linkManId + ' linkMan =' + name + ' class="mui-pull-left " style="color: #376799;padding: 5px 0;" onclick="btndeleteClick(event);">删除</a> ' +
		'		</div> ' +
		'</div>';

	div.innerHTML = str;
	divContactList.appendChild(div);
	showSoftInput(inputNameId);
	keyDownNext(inputNameId,inputPhoneId);
}
function btndeleteClick(event) {
	var linkManId = event.target.getAttribute("linkManId");
	var linkMan = event.target.getAttribute("linkMan");
	var index = event.target.getAttribute("index");
	var devID = 'child' + index;
	var dev = document.getElementById('devID');
	var divContactList = document.getElementById('divContactList');
	if(isEditModel) {
		plus.nativeUI.toast("当前是编辑模式,请先保存!");
	} else {
		var str = "是否确认删除联系人" + linkMan + "吗?";

		var btnArray = ['删除', '取消'];

		mui.confirm(str, '提示', btnArray, function(e) {
			if(e.index == 0) {
				deleteContact(linkManId,linkMan,index);
			}
		});
	}

}
function deleteContact(linkManId,linkMan,index) {
	var param = {
		"linkManId": linkManId,
		"linkMan": linkMan
	};
	var params = {
		"url": getIpAndPort() + "account/deleteLinkMan.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('正在处理...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				plus.nativeUI.toast("成功删除!");
				var devID = 'child' + index;
				var dev = document.getElementById(devID);
				var divContactList = document.getElementById('divContactList');
				divContactList.removeChild(dev);
				getMyContacts();
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("请求失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("获取数据失败，请检查网络！");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function keyDownNext(eid,nextId){
		document.getElementById(eid).addEventListener("keydown",function(e){ 
        if(13 == e.keyCode){ //点击了“搜索”  
//         document.activeElement.blur();//隐藏软键盘 
		   document.getElementById(nextId).focus();
        } 
    },false);
}
function showSoftInput(eId) {
    var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    if (mui.os.android) {
        //强制当前webview获得焦点
        plus.android.importClass(nativeWebview);
		nativeWebview.requestFocus();
		var Context = plus.android.importClass("android.content.Context");
		var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
		var main = plus.android.runtimeMainActivity();
		var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
    } else {
        nativeWebview.plusCallMethod({
            "setKeyboardDisplayRequiresUserAction": false
        });
    }
    var nowInputMile = document.getElementById(eId);
	nowInputMile.focus();
};