var curr, OrderInfo;
var ticketList, payList, channelList, channel,selectPay,selectCusId;
mui.init();
mui.plusReady(function() {
	curr = plus.webview.currentWebview();
	plus.screen.lockOrientation("portrait-primary");
	OrderInfo = curr.OrderInfo;
	getCustomerCouponList();
	
	addReloadPageEvent();
	plus.payment.getChannels(function(channels) {
		channelList = channels;

		mui.each(channelList, function(index, item) {
			if(item.id == 'alipay') {
				channel = item;
			}
		});
	}, function(e) {
		alert("获取支付通道失败：" + e.message);
	});
});

function createPayList(pay, title) {
	if(pay == 'P04')
		return;
	var paylist = document.getElementById('paylist');
	var li = document.createElement('li');
	li.setAttribute('class', 'mui-clearfix');
	li.setAttribute('value', pay);
	li.setAttribute('paytitle', title);
	li.addEventListener("tap", function() {
		var id = this.getAttribute('value');
		var title = this.getAttribute('paytitle');
		var checkDiv = document.getElementById(id);
		selectPay = id;
		for(var key in payList) {
			var div = document.getElementById(key);
			if(div)
				div.setAttribute('class', 'check');
		}
		checkDiv.setAttribute('class', 'check checked');

		mui.each(channelList, function(index, item) {
			if(item.description == title) {
				channel = item;
			}
		});
	});

	var divIcon = document.createElement('div');
	var divCheck = document.createElement('div');
	divCheck.setAttribute('id', pay);
	if(pay == 'P01') { //微信
		divIcon.setAttribute('class', 'icon-pay weixin');
		divCheck.setAttribute('class', 'check');
	} else if(pay == 'P02') {
		divIcon.setAttribute('class', 'icon-pay zhifubao');
		divCheck.setAttribute('class', 'check checked');
		selectPay = pay;
	} else if(pay == 'P03') {
		divIcon.setAttribute('class', 'icon-pay yinlian');
		divCheck.setAttribute('class', 'check');
	}
	var divText = document.createElement('div');
	divText.setAttribute('class', 'pay-text');
	var divTitle = document.createElement('div');
	divTitle.setAttribute('class', 'pay-title');
	divTitle.innerHTML = title;
	divText.appendChild(divTitle);
	li.appendChild(divIcon);
	li.appendChild(divCheck);
	li.appendChild(divText);
	paylist.appendChild(li);
}

function addReloadPageEvent() {
	window.addEventListener('reloadpage', function(event) {
		console.log("cusId:"+event.detail.cusId);
		var CusId = event.detail.cusId;
		if(CusId) {
			var quan = document.getElementById('quan');
			
			mui.each(ticketList, function(index, item1) {
				mui.each(item1.couponList, function(index, item) {
					if(item.nCusID == CusId) {
						quan.innerHTML = '可抵¥' + (item.nAmt - item.nUsedamt);
						selectCusId = item.vCouponNo;
					}
				})
			})
		}
	});
}

function getPayModeList() {
	var param = {};
	var params = {
		"url": getIpAndPort() + "payment/payModeList.do",
		"method": "post",
		"pa": param
	};
	var successcallback = function(response) {
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				payList = response.result.items;
				if(payList) {
					mui.each(channelList, function(index, item) {
						for(var key in payList) {
							if(item.description == payList[key] && item.serviceReady)
								createPayList(key, payList[key]);
						}
					})

				} else {
					var tip = response.message;
					plus.nativeUI.toast(tip);
				}
			}
		} else {
			plus.nativeUI.toast("获取代金券信息失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function getCustomerCouponList() {
	var param = {
		"vehicleId": OrderInfo.nVehicleID,
		"type": 1
	};
	var params = {
		"url": getIpAndPort() + "payment/couponList.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('获取代金券信息中...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				ticketList = response.result;
				initUI();
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取代金券信息失败!");
		}
		getPayModeList();//获取支付方式
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
		getPayModeList();//获取支付方式
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}

function initUI() {
	var orderId = document.getElementById('orderId');
	var materialIOriginalDic = document.getElementById('materialIOriginalDic');
	var workDic = document.getElementById('workDic');
	var totalPrice = document.getElementById('totalPrice');
	var totalPriceDic = document.getElementById('totalPriceDic');

	orderId.innerHTML = OrderInfo.vBillNo;
	if(OrderInfo.nMaterialDisRate == 0) {
		materialIOriginalDic.innerHTML = "材料免费";
	} else if(OrderInfo.nMaterialDisRate == 1) {
		materialIOriginalDic.innerHTML = "材料无优惠";
	} else {
		materialIOriginalDic.innerHTML = "材料" + Number(OrderInfo.nMaterialDisRate * 10).toFixed(2) + "折";
	}
	if(OrderInfo.nManhDisRate == 1) {
		workDic.innerHTML = "工时无优惠";
	} else if(OrderInfo.nManhDisRate == 0) {
		workDic.innerHTML = "工时免费";
	} else {
		workDic.innerHTML = "工时" + Number(OrderInfo.nManhDisRate * 10).toFixed(2) + "折优惠";
	}
	totalPrice.innerHTML = OrderInfo.nMaterialAmtDis+OrderInfo.nManhamtDis;
	totalPriceDic.innerHTML = OrderInfo.nMaterialAmt+OrderInfo.nManhamt;
}

function onPayClick() {
	console.log("selectCusId:"+selectCusId);
	var couponId = selectCusId?selectCusId:"";
	var param = {
		"subId": OrderInfo.nBookingID,
		"couponId":couponId ,
		"payMode": selectPay,
		"vehicleId": OrderInfo.nVehicleID
	};
	var params = {
		"url": getIpAndPort() + "payment/confirmPay.do",
		"method": "post",
		"pa": param
	};
	plus.nativeUI.showWaiting('正在支付中...');
	var successcallback = function(response) {
		plus.nativeUI.closeWaiting();
		curr.show();
		if(response != null) {
			if(response.code == 0) {
				if(response.result.moneyPayAmt>0 && (response.result.payStatus == "0"||response.result.payStatus == "3"))
					pay('alipay', response.result.orderInfo);
			} else {
				var tip = response.message;
				plus.nativeUI.toast(tip);
			}
		} else {
			plus.nativeUI.toast("获取代金券信息失败!");
		}
	};
	var failurecallback = function(xhr, opts) {
		plus.nativeUI.closeWaiting();
		curr.show();
		plus.nativeUI.toast("请求失败!");
	};

	if(checknetwork(true)) {
		ajaxunit(params, successcallback, failurecallback);
	}
}
// 2. 发起支付请求
function pay(id, payinfo) {
	if(!payinfo){
		plus.nativeUI.alert("订单异常，请稍后再试!");
		return;
	}
	// 从服务器请求支付订单
	console.log("channel:" + JSON.stringify(channel));
	console.log("payinfo:" + JSON.stringify(payinfo));
	plus.payment.request(channel, payinfo, function(result) {
		plus.nativeUI.alert("支付成功！", function() {
		    curr.close();
		    goHome();
		});
	}, function(error) {
		console.log("pay error:" + JSON.stringify(error));
		plus.nativeUI.alert("支付失败：" + error.message);
	});

}

function onQuanClick() {
	mui.openWindow({
		url: 'ticket_2.html',
		id: 'page/ticket_2.html',
		styles: {
			top: '0px',
			bottom: '0px'
		}, //窗口参数
		createNew:true,
		extras: {
			tickets: ticketList,
			//			mobile: account.value
		} //自定义扩展参数
	});
}